/* Copyright (c) IBM Corp. 1992 */
 

template < class Element >
Boolean IABag < Element >::
operator == (IABag < Element > const& collection) const
{ return this->containsAllFrom (collection) &&
	 collection.containsAllFrom (*this);
}

template < class Element >
Boolean IABag < Element >::
operator != (IABag < Element > const& collection) const
{ return ! operator == (collection);
}

template < class Element >
void IABag < Element >::
unionWith (IABag < Element > const& collection)
{ addAllFrom (collection);
}

template < class Element >
void IABag < Element >::
intersectionWith (IABag < Element > const& collection)
{ IAEqualityCollection < Element > const* env = &collection;
  removeAll (IAEqualityCollection < Element >::isNotContained, &env);
}

template < class Element >
void IABag < Element >::
differenceWith (IABag < Element > const& collection)
{ IAEqualityCollection < Element > const* env = &collection;
  removeAll (IAEqualityCollection < Element >::isContained, &env);
}

template < class Element >
void IABag < Element >::
addUnion (IABag < Element > const& collection1,
          IABag < Element > const& collection2)
{ addAllFrom (collection1);
  addAllFrom (collection2);
}

template < class Element >
void IABag < Element >::
addIntersection (IABag < Element > const& collection1,
                 IABag < Element > const& collection2)
{ ICursor *cursor = collection1.newCursor ();
  forCursor (*cursor) {
    if (collection2.contains (collection1.elementAt (*cursor)))
      add (collection1.elementAt (*cursor));
  }
  delete cursor;
}

template < class Element >
void IABag < Element >::
addDifference (IABag < Element > const& collection1,
               IABag < Element > const& collection2)
{ ICursor *cursor = collection1.newCursor ();
  forCursor (*cursor) {
    if (! collection2.contains (collection1.elementAt (*cursor)))
      add (collection1.elementAt (*cursor));
  }
  delete cursor;
}

