/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IABAG_H
#define _IABAG_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>

template < class Element >
class IABag : public virtual IAEqualityCollection < Element > {
public:

  virtual Boolean        operator ==                 (IABag < Element > const&) const;

  virtual Boolean        operator !=                 (IABag < Element > const&) const;

  virtual void           unionWith                   (IABag < Element > const&);

  virtual void           intersectionWith            (IABag < Element > const&);

  virtual void           differenceWith              (IABag < Element > const&);

  virtual void           addUnion                    (IABag < Element > const&,
                                               IABag < Element > const&);

  virtual void           addIntersection             (IABag < Element > const&,
                                               IABag < Element > const&);

  virtual void           addDifference               (IABag < Element > const&,
                                               IABag < Element > const&);

protected:

};

#ifdef __IBMCPP__
#include <iabag.c>
#endif

#endif
