#ifndef _IABMENU_
  #define _IABMENU_
/**************************************************************/
/* FILE NAME: iabmenu.hpp                                     */
/*                                                            */
/* DESCRIPTION:                                               */
/*    Declaration of the class:                               */
/*      IActionBarMenu - menu bar created from a resource     */
/*                                                            */
/* COPYRIGHT:                                                 */
/*   Licensed Materials - Property of IBM                     */
/*   (c) Copyright IBM Corporation 1992, 1993                 */
/*   US Government Users Restricted Rights - Use duplication  */
/*   or disclosure restricted by GSA ADP Schedule Contract    */
/*   with IBM Corp.                                           */
/*                                                            */
/* $Log:   G:/IBMCLASS/IBASEAPP/VCS/IABMENU.HPV  $                                                      */
// 
//    Rev 1.2   26 Oct 1992 10:00:40   HARPERSP
// Updates for standardized header documentation.
/*                                                            */
/**************************************************************/

#ifndef _IMENU_
#include <imenu.hpp>
#endif

// Forward declarations for other classes
class   IActionBarMenu;     /*  abmn  */
class   IWindow;
class   IWindowHandle;
class   IResourceId;

class IActionBarMenu : public IMenu
{
/**********************************************************************
* Creates an ActionBar Menu from an IResourceId and assigns it to     *
* an IWindow (typically an IFrame or an IDialog).                     *
*                                                                     *
* Example:                                                            *
*   IActionBarMenu menu(ID_ACTIONBAR, myFrame);                       *
*     menu identified by resource ID_ACTIONBAR is assigned to myFrame *
*                                                                     *
*   menu.setMenu(ID_OTHERACTIONBAR);                                  *
*     menu is changed to one identified by ID_OTHERACTIONBAR          *
*                                                                     *
* The member functions in IMenu and ISubMenu can be used to           *
* change the IActionBarMenu. IMenuItem objects can be added to the    *
* IActionBarMenu.                                                     *
**********************************************************************/
  public:
/*------------------ CONSTRUCTORS/DESTRUCTORS -------------------------
|  There is 1 way to construct instances of this class:               |
|    1. IActionBarMenu(const IResourceId& menuResId,                  |
|                      const IWindow* const owner);                   |
|                                                                     |
---------------------------------------------------------------------*/

     IActionBarMenu(const IResourceId& menuResId,
                    const IWindow* const owner);
     ~IActionBarMenu();

/*---------------------- ACCESSORS ------------------------------------
|                                                                     |
| void setMenu() - changes the menu to the one passed in              |
|                                                                     |
---------------------------------------------------------------------*/
     void setMenu(const IResourceId& menuResId);

  private:
/*----------------------- PRIVATE -----------------------------------*/
     void create(const IResourceId& menuResId);
     const IWindow* pwndClOwner;
};
#endif  /* _IABMENU_ */
