/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IACLLCT_H
#define _IACLLCT_H

#include <iglobals.h>
#include <icursor.h>

template < class Element >
class IACollection {
public:

  virtual                ~IACollection             ();

  virtual Boolean        add                         (Element const&) = 0;

  virtual Boolean        add                         (Element const&,
                                               ICursor&) = 0;

  virtual void           addAllFrom                  (IACollection <Element> const&);

  virtual void           copy                        (IACollection
                                                  <Element> const&);

  virtual Element const& elementAt                   (ICursor const&) const = 0;

  virtual Element&       elementAt                   (ICursor const&) = 0;

  virtual Element const& anyElement                  () const = 0;

  virtual void           removeAt                    (ICursor const&) = 0;

  virtual INumber        removeAll                   (Boolean (*property)
                                               (Element const&, void*),
                                               void* additionalArgument = 0) = 0;

  virtual void           replaceAt                   (ICursor const&,
                                               Element const&) = 0;

  virtual void           removeAll                   () = 0;

  virtual Boolean        isBounded                   () const = 0;

  virtual INumber        maxNumberOfElements         () const = 0;

  virtual INumber        numberOfElements            () const = 0;

  virtual Boolean        isEmpty                     () const = 0;

  virtual Boolean        isFull                      () const = 0;

  virtual ICursor*       newCursor                   () const = 0;

  virtual Boolean        setToFirst                  (ICursor&) const = 0;

  virtual Boolean        setToNext                   (ICursor&) const = 0;

  virtual Boolean        allElementsDo               (Boolean (*function)
                                                  (Element&, void*),
                                               void* additionalArgument = 0) = 0;

  virtual Boolean        allElementsDo               (IIterator <Element>&) = 0;

  virtual Boolean        allElementsDo               (Boolean (*function)
                                               (Element const&, void*),
                                               void* additionalArgument = 0)
                                               const = 0;

  virtual Boolean        allElementsDo               (IConstantIterator
                                                  <Element>&) const = 0;

};

#ifdef __IBMCPP__
#include <iacllct.c>
#endif

#endif
