/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IAEQSEQ_H
#define _IAEQSEQ_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>
#include <iasqntl.h>

template < class Element >
class IAEqualitySequence :
  public virtual IAEqualityCollection < Element >,
  public virtual IASequentialCollection < Element > {
public:

  virtual Boolean        operator ==                 (IAEqualitySequence < Element > const&) const;

  virtual Boolean        operator !=                 (IAEqualitySequence < Element > const&) const;

  virtual void           unionWith                   (IAEqualitySequence < Element > const&);

  virtual void           intersectionWith            (IAEqualitySequence < Element > const&);

  virtual void           differenceWith              (IAEqualitySequence < Element > const&);

  virtual void           addUnion                    (IAEqualitySequence < Element > const&,
                                               IAEqualitySequence < Element > const&);

  virtual void           addIntersection             (IAEqualitySequence < Element > const&,
                                               IAEqualitySequence < Element > const&);

  virtual void           addDifference               (IAEqualitySequence < Element > const&,
                                               IAEqualitySequence < Element > const&);

  virtual long           compare                     (IAEqualitySequence < Element > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

};

#ifdef __IBMCPP__
#include <iaeqseq.c>
#endif

#endif
