/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IAKEYSET_H
#define _IAKEYSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iakey.h>

template < class Element, class Key >
class IAKeySet : public virtual IAKeyCollection < Element, Key > {
public:

protected:

   INumber        numberOfElementsWithKey     (Key const&) const;

   Boolean        locateNextElementWithKey    (Key const&,
                                               ICursor&) const;

   INumber        removeAllElementsWithKey    (Key const&);

   INumber        numberOfDifferentKeys       () const;

   Boolean        setToNextWithDifferentKey   (ICursor&) const;

};

#ifdef __IBMCPP__
#include <iakeyset.c>
#endif

#endif
