/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IAKSSET_H
#define _IAKSSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaksrt.h>

template < class Element, class Key >
class IAKeySortedSet :
  public virtual IAKeySortedCollection < Element, Key > {
public:

  virtual long           compare                     (IAKeySortedSet < Element, Key > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

   INumber        numberOfElementsWithKey     (Key const&) const;

   Boolean        locateNextElementWithKey    (Key const&,
                                               ICursor&) const;

   INumber        removeAllElementsWithKey    (Key const&);

   INumber        numberOfDifferentKeys       () const;

   Boolean        setToNextWithDifferentKey   (ICursor&) const;

};

#ifdef __IBMCPP__
#include <iaksset.c>
#endif

#endif
