/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IAORDER_H
#define _IAORDER_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

template < class Element >
class IAOrderedCollection : public virtual IACollection < Element > {
public:

  virtual void           removeFirst                 () = 0;

  virtual void           removeLast                  () = 0;

  virtual void           removeAtPosition            (IPosition) = 0;

  virtual Element const& firstElement                () const = 0;

  virtual Element const& lastElement                 () const = 0;

  virtual Element const& elementAtPosition           (IPosition) const = 0;

  virtual Boolean        setToLast                   (ICursor&) const = 0;

  virtual Boolean        setToPrevious               (ICursor&) const = 0;

  virtual void           setToPosition               (IPosition,
                                               ICursor&) const = 0;

  virtual Boolean        isFirst                     (ICursor const&) const = 0;

  virtual Boolean        isLast                      (ICursor const&) const = 0;

};

#endif
