/* Copyright (c) IBM Corp. 1992 */
 

template < class Element >
INumber IASet < Element >::
numberOfOccurrences (Element const& element) const
{ if (contains (element))
    return 1;
  else
    return 0;
}

template < class Element >
Boolean IASet < Element >::
locateNext (Element const&, ICursor& cursor) const
{ cursor.invalidate ();
  return False;
}

template < class Element >
INumber IASet < Element >::
removeAllOccurrences (Element const& element)
{ if (remove (element))
    return 1;
  else
    return 0;
}

template < class Element >
INumber IASet < Element >::
numberOfDifferentElements () const
{ return numberOfElements ();
}

template < class Element >
Boolean IASet < Element >::
setToNextDifferentElement (ICursor& cursor) const
{ return setToNext (cursor);
}

template < class Element >
Boolean IASet < Element >::
operator == (IASet < Element > const& collection) const
{ return this->containsAllFrom (collection) &&
	 collection.containsAllFrom (*this);
}

template < class Element >
Boolean IASet < Element >::
operator != (IASet < Element > const& collection) const
{ return ! operator == (collection);
}

template < class Element >
void IASet < Element >::
unionWith (IASet < Element > const& collection)
{ addAllFrom (collection);
}

template < class Element >
void IASet < Element >::
intersectionWith (IASet < Element > const& collection)
{ IAEqualityCollection < Element > const* env = &collection;
  removeAll (IAEqualityCollection < Element >::isNotContained, &env);
}

template < class Element >
void IASet < Element >::
differenceWith (IASet < Element > const& collection)
{ IAEqualityCollection < Element > const* env = &collection;
  removeAll (IAEqualityCollection < Element >::isContained, &env);
}

template < class Element >
void IASet < Element >::
addUnion (IASet < Element > const& collection1,
          IASet < Element > const& collection2)
{ addAllFrom (collection1);
  addAllFrom (collection2);
}

template < class Element >
void IASet < Element >::
addIntersection (IASet < Element > const& collection1,
                 IASet < Element > const& collection2)
{ ICursor *cursor = collection1.newCursor ();
  forCursor (*cursor) {
    if (collection2.contains (collection1.elementAt (*cursor)))
      add (collection1.elementAt (*cursor));
  }
  delete cursor;
}

template < class Element >
void IASet < Element >::
addDifference (IASet < Element > const& collection1,
               IASet < Element > const& collection2)
{ ICursor *cursor = collection1.newCursor ();
  forCursor (*cursor) {
    if (! collection2.contains (collection1.elementAt (*cursor)))
      add (collection1.elementAt (*cursor));
  }
  delete cursor;
}

