/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IASQNTL_H
#define _IASQNTL_H

#include <iglobals.h>
#include <icursor.h>
#include <iaorder.h>

template < class Element >
class IASequentialCollection :
  public virtual IAOrderedCollection < Element > {
public:

  virtual void           addAsFirst                  (Element const&) = 0;

  virtual void           addAsFirst                  (Element const&,
                                               ICursor&) = 0;

  virtual void           addAsLast                   (Element const&) = 0;

  virtual void           addAsLast                   (Element const&,
                                               ICursor&) = 0;

  virtual void           addAsNext                   (Element const&,
                                               ICursor&) = 0;

  virtual void           addAsPrevious               (Element const&,
                                               ICursor&) = 0;

  virtual void           addAtPosition               (IPosition,
                                               Element const&) = 0;

  virtual void           addAtPosition               (IPosition,
                                               Element const&,
                                               ICursor&) = 0;

  virtual void           sort                        (long (*comparisonFunction)
                                               (Element const&,
                                               Element const&)) = 0;

};

#endif
