/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IASRTBAG_H
#define _IASRTBAG_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqsrt.h>

template < class Element >
class IASortedBag :
  public virtual IAEqualitySortedCollection < Element > {
public:

  virtual Boolean        operator ==                 (IASortedBag < Element > const&) const;

  virtual Boolean        operator !=                 (IASortedBag < Element > const&) const;

  virtual void           unionWith                   (IASortedBag < Element > const&);

  virtual void           intersectionWith            (IASortedBag < Element > const&);

  virtual void           differenceWith              (IASortedBag < Element > const&);

  virtual void           addUnion                    (IASortedBag < Element > const&,
                                               IASortedBag < Element > const&);

  virtual void           addIntersection             (IASortedBag < Element > const&,
                                               IASortedBag < Element > const&);

  virtual void           addDifference               (IASortedBag < Element > const&,
                                               IASortedBag < Element > const&);

  virtual long           compare                     (IASortedBag < Element > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

};

#ifdef __IBMCPP__
#include <iasrtbag.c>
#endif

#endif
