/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IASRTSET_H
#define _IASRTSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqsrt.h>

template < class Element >
class IASortedSet :
  public virtual IAEqualitySortedCollection < Element > {
public:

  virtual Boolean        operator ==                 (IASortedSet < Element > const&) const;

  virtual Boolean        operator !=                 (IASortedSet < Element > const&) const;

  virtual void           unionWith                   (IASortedSet < Element > const&);

  virtual void           intersectionWith            (IASortedSet < Element > const&);

  virtual void           differenceWith              (IASortedSet < Element > const&);

  virtual void           addUnion                    (IASortedSet < Element > const&,
                                               IASortedSet < Element > const&);

  virtual void           addIntersection             (IASortedSet < Element > const&,
                                               IASortedSet < Element > const&);

  virtual void           addDifference               (IASortedSet < Element > const&,
                                               IASortedSet < Element > const&);

  virtual long           compare                     (IASortedSet < Element > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

   INumber        numberOfOccurrences         (Element const&) const;

   Boolean        locateNext                  (Element const&, ICursor&)
                                               const;

   INumber        removeAllOccurrences        (Element const&);

   INumber        numberOfDifferentElements   () const;

   Boolean        setToNextDifferentElement   (ICursor&) const;

};

#ifdef __IBMCPP__
#include <iasrtset.c>
#endif

#endif
