#ifndef _ICMDEVT_
#define _ICMDEVT_
/*******************************************************************************
* FILE NAME: icmdevt.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     ICommandEvent - the command event class                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*$Log:   R:/IBMCLASS/IBASEAPP/VCS/ICMDEVT.HPV  $                                                                         *
// 
//    Rev 1.3   25 Oct 1992 17:59:12   nunn
// Brad Broyles changes for external beta

      Rev 1.1   01 Jan 1989 12:00:00   LM & KKL
   Initiate code
      Rev 1.2   17 Sep 1992 12:00:00   KKL
   Make individual file
      Rev 1.3   22 Oct 1992 12:00:00   WBB
   Amend to match skeleton.hpp
*******************************************************************************/

// Forward declarations for other classes:
class ICommandEvent;
class ISize;
#if !defined( _IEVENT_ ) && !defined( I_NO_RELATED_HPP )
  #include <ievent.hpp>
#endif

class ICommandEvent  : public IEvent {
/*******************************************************************************
* The ICommandEvent class is the command event class                           *
*******************************************************************************/
typedef IEvent Inherited;
public:
/*------------------------ CONSTRUCTORS/DESTRUCTORS ----------------------------
| There is one way to construct instances of this class:                       |
|   1. from an instance of IEvent                                              |
|     The event class instance is used to create the ICommandEvent instance    |
------------------------------------------------------------------------------*/
   ICommandEvent(IEvent& evt);

/*-------------------------------- ACCESSORS -----------------------------------
| These function provide means of getting and setting the accessible           |
| attributes of instances of this class:                                       |
|   sourceId - return an ID that identifies the source of the command event    |
|   commandId - return the pushbutton ID, menu item ID, etc.                   |
------------------------------------------------------------------------------*/
   enum {unknownCmd=0, pushButtonCmd=1, menuCmd=2,
         accelCmd=3, fontDialogCmd=4, fileDialogCmd=5,
         printDialogCmd=6, colorDialogCmd=7};

unsigned long
  sourceId() const,
  commandId() const;
}; // ICommandEvent

/*--------------------------------- INLINES ----------------------------------*/
#ifndef I_NO_INLINES
  #include <icmdevt.inl>
#endif

#endif /* ICMDEVT */
