#ifndef _ICMDHDR_
#define _ICMDHDR_
/*******************************************************************************
* FILE NAME: icmdhdr.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     ICommandHandler - the command event handler class                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*$Log:   R:/IBMCLASS/IBASEAPP/VCS/ICMDHDR.HPV  $                                                                         *
// 
//    Rev 1.22   25 Oct 1992 17:59:38   nunn
// Brad Broyles changes for external beta

      Rev 1.1   08 Aug 1992 12:00:00   KKL
   Design/code
      Rev 1.2   22 Oct 1992 12:00:00   WBB
   Amend to match skeleton.hpp
*******************************************************************************/

// Forward declarations for other classes:
class ICommandHandler;
#if !defined( _IHANDLER_ ) && !defined( I_NO_RELATED_HPP )
 #include <ihandler.hpp>
#endif
#if !defined( _ICMDEVT_ ) && !defined( I_NO_RELATED_HPP )
 #include <icmdevt.hpp>
#endif

class ICommandHandler : public IHandler {
/*******************************************************************************
* The ICommandHandler class dispatches WM_COMMAND messages as                  *
* command(ICommandEvent&) functions.                                           *
*******************************************************************************/
typedef IHandler Inherited;
public:
/*------------------------ CONSTRUCTORS/DESTRUCTORS ----------------------------
| There is one way to construct instances of this class:                       |
|   1. default                                                                 |
------------------------------------------------------------------------------*/
  ICommandHandler() {;}

/*-------------------------------- FUNCTIONS -----------------------------------
| dispatchHandlerEvent - dispatch command events for this handler              |
------------------------------------------------------------------------------*/
Boolean
  dispatchHandlerEvent(IEvent& evt);

protected:
/*----------------------------- IMPLEMENTATION ---------------------------------
| command - implemented by subclasses to handle the command events             |
------------------------------------------------------------------------------*/
virtual Boolean
  command(ICommandEvent& cmdevt) = 0;
}; // ICommandHandler

#endif /* ICMDHDR */
