inline IEvent::IEvent(const IEvent& evtCopy)
/**************************************************************/
/* Copy constructor.                                          */
/**************************************************************/
 : hCl(evtCopy.hCl), ulClEvtId(evtCopy.ulClEvtId),
   epCl1(evtCopy.epCl1), epCl2(evtCopy.epCl2), erCl(evtCopy.erCl)
{;}

inline const IHandle& IEvent::handle() const
/**************************************************************/
/* Return the handle of the window or queue receiving the     */
/* event.                                                     */
/**************************************************************/
{ return hCl; }

inline unsigned long IEvent::eventId() const
/**************************************************************/
/* Return the event ID.                                       */
/**************************************************************/
{ return ulClEvtId; }

inline const IEventParam& IEvent::param1() const
/**************************************************************/
/* Return the first event parameter.                          */
/**************************************************************/
{ return epCl1; }

inline const IEventParam& IEvent::param2() const
/**************************************************************/
/* Return the second event parameter.                         */
/**************************************************************/
{ return epCl2; }

inline void IEvent::setResult(IEventResult er)
/**************************************************************/
/* Set the event result.                                      */
/**************************************************************/
{ erCl = er; }

inline IEventResult IEvent::result() const
/**************************************************************/
/* Return the event result.                                   */
/**************************************************************/
{ return erCl; }
