inline IEventParam::IEventParam()
/**************************************************************/
/* Make void MPARAM.                                          */
/**************************************************************/
 : pvClMsg(0)
{;}

inline IEventParam::IEventParam(void* pv)
/**************************************************************/
/* Make MPARAM from pointer.                                  */
/**************************************************************/
{
   pvClMsg = (void*)((unsigned long)pv);
}

inline IEventParam::IEventParam(unsigned long ul)
/**************************************************************/
/* Make MPARAM from long.                                     */
/**************************************************************/
{
   pvClMsg = (void*)((unsigned long)ul);
}

//inline IEventParam::IEventParam(unsigned char uch)
/**************************************************************/
/* Make MPARAM from char.                                     */
/**************************************************************/
//{
//   pvClMsg = (void*)((unsigned short)uch);
//}

inline IEventParam::IEventParam(const IEventParam& epCopy)
/**************************************************************/
/* Copy constructor.                                          */
/**************************************************************/
{
  pvClMsg = epCopy.pvClMsg;
}

inline unsigned char IEventParam::char1() const
/**************************************************************/
/* Extract unsigned char 1 from message param.                */
/**************************************************************/
{
   return (unsigned char)(unsigned long)pvClMsg;
}

inline unsigned char IEventParam::char2() const
/**************************************************************/
/* Extract unsigned char 2 from message param.                */
/**************************************************************/
{
   return (unsigned char)((unsigned long)pvClMsg >> 8);
}

inline unsigned char IEventParam::char3() const
/**************************************************************/
/* Extract unsigned char 3 from message param.                */
/**************************************************************/
{
   return (unsigned char)((unsigned long)pvClMsg >> 16);
}

inline unsigned char IEventParam::char4() const
/**************************************************************/
/* Extract unsigned char 4 from message param.                */
/**************************************************************/
{
   return (unsigned char)((unsigned long)pvClMsg >> 24);
}


inline unsigned long IEventParam::number1() const
/**************************************************************/
/* Extract lower two bytes from message param.                */
/**************************************************************/
{
   return (unsigned short)(unsigned long)pvClMsg;
}

inline unsigned long IEventParam::number2() const
/**************************************************************/
/* Extract upper two bytes from message param.                */
/**************************************************************/
{
   return ((unsigned long)pvClMsg >> 16);
}

inline IEventParam& IEventParam::operator=(const IEventParam& ep)
/**************************************************************/
/* Assignment operator                                        */
/**************************************************************/
{
   pvClMsg = ep.pvClMsg;
   return *this;
}

inline IEventParam::operator void*() const
/**************************************************************/
/* Cast operator to void pointer.                             */
/**************************************************************/
{ return pvClMsg; }

inline IEventParam::operator char*() const
/**************************************************************/
/* Cast operator to char*                                     */
/**************************************************************/
{ return (char*)pvClMsg; }

inline IEventParam::operator unsigned long() const
/**************************************************************/
/* Case message parameter to unsigned long.                   */
/**************************************************************/
{
   return (unsigned long)pvClMsg;
}
