#ifndef _IHANDLER_
  #define _IHANDLER_
/**************************************************************/
/* CLASS NAME:  IHandler                                      */
/*                                                            */
/* DESCRIPTION  : This is the base handler class.             */
/*                                                            */
/* Hungarian is h                                             */
/*                                                            */
/* CHANGE ACTIVITY:                                           */
/*   DATE:     INITIAL:        DESCRIPTION                    */
/*                                                            */
/*   080892    Kevin Leong     Design/code                    */
/*                                                            */
/**************************************************************/
/* Copyright (c) IBM Corporation 1991                         */
/**************************************************************/
class IHandler;
class IEvent;
class IString;
#ifndef _IVBASE_
  #include <ivbase.hpp>
#endif
#ifndef _IEVENT_
  #include <ievent.hpp>
#endif

class IHandler : public IVBase
{
  typedef IVBase Inherited;
  public:
    IHandler();
    virtual Boolean dispatchHandlerEvent(IEvent& evt) = 0;
    void enable();
    void disable();
    Boolean isEnabled() const;

    virtual IString dump();

  private:
    Boolean bEnabled;
};

inline IHandler::IHandler()
/**************************************************************/
/* Constructor.                                               */
/**************************************************************/
 : bEnabled(true)
{;}

inline void IHandler::enable()
/**************************************************************/
/* Disable this SHandler.                                     */
/**************************************************************/
{ bEnabled = true; }

inline void IHandler::disable()
/**************************************************************/
/* Disable this SHandler.                                     */
/**************************************************************/
{ bEnabled = false; }

inline Boolean IHandler::isEnabled() const
/**************************************************************/
/* Is this SHandler enabled?                                  */
/**************************************************************/
{ return bEnabled; }
#endif /* IHANDLER */
