/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IHEAPSEQ_H
#define _IHEAPSEQ_H

#include <iglobals.h>
#include <icursor.h>

template < class Element, class ElementOps, class Base >
class IWHeapOnSeq {
  Base ivBase;
  class Cursor;
  friend class Cursor;
public:

  class Cursor : public Base::Cursor {
  public:
    Cursor (IWHeapOnSeq
	      < Element, ElementOps, Base > const& c)
    : Base::Cursor (c.ivBase) {}
  };

                  IWHeapOnSeq             (INumber
                                               numberOfElements = 100,
                                               IBoundIndicator =
                                               IUnbounded);

                  IWHeapOnSeq             (IWHeapOnSeq < Element, ElementOps, Base > const&);

   IWHeapOnSeq < Element, ElementOps, Base >&    operator =                  (IWHeapOnSeq < Element, ElementOps, Base > const&);

                 ~IWHeapOnSeq             ();

   Boolean        add                         (Element const&);

   Boolean        add                         (Element const&,
                                               ICursor&);

   void           addAllFrom                  (IWHeapOnSeq < Element, ElementOps, Base > const&);

   Element const& elementAt                   (ICursor const&) const;

   Element&       elementAt                   (ICursor const&);

   Element const& anyElement                  () const;

   void           removeAt                    (ICursor const&);

   INumber        removeAll                   (Boolean (*property)
                                               (Element const&, void*),
                                               void* additionalArgument = 0);

   void           replaceAt                   (ICursor const&,
                                               Element const&);

   void           removeAll                   ();

   Boolean        isBounded                   () const;

   INumber        maxNumberOfElements         () const;

   INumber        numberOfElements            () const;

   Boolean        isEmpty                     () const;

   Boolean        isFull                      () const;

   ICursor*       newCursor                   () const;

   Boolean        setToFirst                  (ICursor&) const;

   Boolean        setToNext                   (ICursor&) const;

   Boolean        allElementsDo               (Boolean (*function)
                                                  (Element&, void*),
                                               void* additionalArgument = 0);

   Boolean        allElementsDo               (IIterator <Element>&);

   Boolean        allElementsDo               (Boolean (*function)
                                               (Element const&, void*),
                                               void* additionalArgument = 0)
                                               const;

   Boolean        allElementsDo               (IConstantIterator
                                                  <Element>&) const;

};

#define IDefineGHeapOnGSequence(GSeq, GHeap) \
template < class Element, class ElementOps > \
class GHeap : \
  public IWHeapOnSeq < Element, ElementOps, \
		       GSeq < Element, ElementOps > > { \
public: \
  GHeap (INumber n = 100, IBoundIndicator b = IUnbounded) : \
    IWHeapOnSeq < Element, ElementOps, \
		  GSeq < Element, ElementOps > > (n, b) {} \
};

#include <iheapseq.if>

#endif
