#ifndef _IKEYHDR_
#define _IKEYHDR_
/*******************************************************************************
* FILE NAME: ikeyhdr.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IKeyboardHandler - the keyboard event handler class                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*$Log:   R:/IBMCLASS/IBASEAPP/VCS/IKEYHDR.HPV  $                                                                         *
// 
//    Rev 1.22   25 Oct 1992 18:00:24   nunn
// Brad Broyles changes for external beta

      Rev 1.1   08 Aug 1992 12:00:00   KKL
   Design/code
      Rev 1.2   22 Oct 1992 12:00:00   WBB
   Amend to match skeleton.hpp
*******************************************************************************/

// Forward declarations for other classes:
class IKeyboardHandler;
#if !defined( _IHANDLER_ ) && !defined( I_NO_RELATED_HPP )
 #include <ihandler.hpp>
#endif
#if !defined( _IKEYEVT_ ) && !defined( I_NO_RELATED_HPP )
 #include <ikeyevt.hpp>
#endif

class IKeyboardHandler : public IHandler {
/*******************************************************************************
* The IKeyboardHandler class handles keyboard events                           *
*******************************************************************************/
typedef IHandler Inherited;
public:
/*------------------------ CONSTRUCTORS/DESTRUCTORS ----------------------------
| There is one way to construct instances of this class:                       |
|   1. default                                                                 |
------------------------------------------------------------------------------*/
  IKeyboardHandler() {;}

/*-------------------------------- FUNCTIONS -----------------------------------
| dispatchHandlerEvent - dispatch command functions for this handler           |
------------------------------------------------------------------------------*/
Boolean
  dispatchHandlerEvent(IEvent& evt);

protected:
/*----------------------------- IMPLEMENTATION ---------------------------------
| keyPress - subclasses implement this function to handle key presses          |
------------------------------------------------------------------------------*/
virtual Boolean
  keyPress(IKeyboardEvent& keyevt) = 0;
}; // IKeyboardHandler

#endif /* _IKEYHDR_ */
