#ifndef _IMCHDR_
#define _IMCHDR_
/*******************************************************************************
* FILE NAME: imchdr.hpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IMouseClickHandler - Mouse Click Handler class                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*$Log:   R:/IBMCLASS/IBASEAPP/VCS/IMCHDR.HPV  $                                                                         *
// 
//    Rev 1.22   25 Oct 1992 18:00:38   nunn
// Brad Broyles changes for external beta

      Rev 1.1   08 Aug 1992 12:00:00   KKL
   Design/code
      Rev 1.1   22 Oct 1992 12:00:00   WBB
   Amend to match skeleton.hpp
*******************************************************************************/

// Forward declarations for other classes:
class IMouseClickHandler;
#if !defined( _IHANDLER_ ) && !defined( I_NO_RELATED_HPP )
 #include <ihandler.hpp>
#endif
#if !defined( _IMCEVT_ ) && !defined( I_NO_RELATED_HPP )
 #include <imcevt.hpp>
#endif

class IMouseClickHandler : public IHandler {
/*******************************************************************************
* The IMouseClickHandler class handles mouse click events.                     *
*******************************************************************************/
typedef IHandler Inherited;
public:
/*------------------------ CONSTRUCTORS/DESTRUCTORS ----------------------------
| There is one way to construct instances of this class:                       |
|   1. default                                                                 |
------------------------------------------------------------------------------*/
  IMouseClickHandler() {;}

/*-------------------------------- FUNCTIONS -----------------------------------
| dispatchHandlerEvent - dispatch command functions for this handler           |
------------------------------------------------------------------------------*/
Boolean
  dispatchHandlerEvent(IEvent& evt);

protected:
/*----------------------------- IMPLEMENTATION ---------------------------------
| mouseClicked - implemented by subclass to handle mouse clicked event         |
------------------------------------------------------------------------------*/
virtual Boolean
  mouseClicked(IMouseClickEvent& keyevt) = 0;
}; // IMouseClickHandler

#endif /* IMCHDR */
