#ifndef _IMENUEVT_
  #define _IMENUEVT_
/**************************************************************/
/* FILE NAME: imenuevt.hpp                                    */
/*                                                            */
/* DESCRIPTION:                                               */
/*    Declaration of the class:                               */
/*      IMenuEvent - wrapper for events related to menus      */
/*                                                            */
/* COPYRIGHT:                                                 */
/*   Licensed Materials - Property of IBM                     */
/*   (c) Copyright IBM Corporation 1992, 1993                 */
/*   US Government Users Restricted Rights - Use duplication  */
/*   or disclosure restricted by GSA ADP Schedule Contract    */
/*   with IBM Corp.                                           */
/*                                                            */
//      $Log:   G:/IBMCLASS/IBASEAPP/VCS/IMENUEVT.HPV  $                                                 */
// 
//    Rev 1.22   26 Oct 1992 10:07:46   HARPERSP
// Updates for documentation.
//
//   Rev 1.20   18 Oct 1992 18:48:34   greg
//Fixes for wrong handler bug
// 
//    Rev 1.2   13 Oct 1992 22:40:22   kleong
// Minor update...
//
//    Rev 1.1   08 Oct 1992 09:25:12   HARPERSP
// First update using $Log$
// Had to re-PUT because comment prefix was wrong.
/*                                                            */
/**************************************************************/
#ifndef _IEVENT_
  #include <ievent.hpp>
#endif
#ifndef _IPOINT_
  #include <ipoint.hpp>
#endif

// Forward declarations for other classes
class IMenuEvent;
class ISubMenu;

class IMenuEvent  : public IEvent

/**********************************************************************
* Instances of this class are passed on the virtual handler           *
* functions (callbacks) of the IMenuHandler class.                    *
*                                                                     *
**********************************************************************/

{
  typedef IEvent Inherited;
  public:

/*------------------ CONSTRUCTORS/DESTRUCTORS -------------------------
|  There is 1 way to construct instances of this class:               |
|     IMenuEvent(IEvent& evt)                                         |
|                                                                     |
|  You should not ever need to construct an IMenuEvent instance.      |
|  The low-level event handler classes are responsible for            |
|  creating IMenuEvent instances.                                     |
|  These instances are passed to you via the IMenuHandler             |
|  callback functions.                                                |
---------------------------------------------------------------------*/

     IMenuEvent(IEvent& evt) : IEvent(evt) {;}


/*---------------------- ACCESSORS ------------------------------------
| These routines are very useful inside of the IMenuHandler           |
| callback functions.                                                 |
|                                                                     |
| menuItemId - returns of the id of the selected Menu Item            |
|                                                                     |
| mousePosition - returns an IPoint that specifies the mouse          |
|                 position at the time the menu event occurred.       |
|                 Useful for positioning PopUp Menus.                 |
|                                                                     |
---------------------------------------------------------------------*/

     unsigned long menuItemId() const;
     IPoint mousePosition() const;
};

#endif /* IMENUEVT */
