/*****************************************************************************
*                                                                            *
* Name: imprintf - IMemMgr Version of the PMPRINTF function                  *
*                                                                            *
* Description:                                                               *
*                                                                            *
*  This file provides the definitions necessary to use the "imprintf"        *
*  library function within a PM program.  All "printf" output is             *
*  directed to a separate window on the PM Desktop that is maintained by the *
*  PMPRINTF.EXE program.  PMPRINTF.EXE must be loaded BEFORE any             *
*                                                                            *
*  Note: imprintf() is a specially modified version of PMPRINT that doesn't  *
*  call malloc() and uses a semaphore to address multithread issues.         *
*                                                                            *
*****************************************************************************/
#ifndef _IMPRINTF
#define _IMPRINTF

// Define a macro to convert all occurrences of the "printf" library
// call name to call the internal program.  This is required do the
// the problem of duplicate symbol definition errors from the linker.
// #define printf imprintf

// Here's the prototype for the internal "printf" work-a-like function
// int _cdecl imprintf(const char *,...);
extern "C" int  imprintf(const char *,...);

#endif
