#ifndef _IPAGEEVT_
  #define _IPAGEEVT_
/**************************************************************/
/* CLASS NAME:  IPageEvent                                    */
/*                                                            */
/* DESCRIPTION  : This is the notebook page notification      */
/*                event information class.                    */
/*                                                            */
/* Hungarian is nbpevt                                        */
/*                                                            */
/* CHANGE ACTIVITY:                                           */
/*   DATE:     INITIAL:        DESCRIPTION                    */
/*                                                            */
/*   092492    KKL             Make individual file.          */
/*                                                            */
/**************************************************************/
/* Copyright (c) IBM Corporation 1992                         */
/**************************************************************/
class IPageEvent;

#ifndef _ICTLEVT_
  #include <ictlevt.hpp>
#endif

class IPageEvent  : public IControlEvent
{
  typedef IControlEvent Inherited;
  public:
     IPageEvent(IEvent& evt);
     IPageEvent(IControlEvent& evt);

     unsigned long topPageId() const;
     unsigned long newTopPageId() const;
};

inline IPageEvent :: IPageEvent(IEvent& evt)
/***************************************************************/
/* Constructor.                                                */
/***************************************************************/
   : IControlEvent(evt)
{;}

inline IPageEvent :: IPageEvent(IControlEvent& ctlevt)
/***************************************************************/
/* Constructor.                                                */
/***************************************************************/
   : IControlEvent(ctlevt)
{;}
#endif /* IPAGEEVT */
