/* Copyright (c) IBM Corp. 1992 */
template <class Element, class ElementOps, class Base>
Boolean IWSrtBagOnKSSet <Element, ElementOps, Base>::Cursor::setToFirst ()
{ occurrence = 1;
  return ivCollection->setToFirst (*this);
}

template <class Element, class ElementOps, class Base>
Boolean IWSrtBagOnKSSet <Element, ElementOps, Base>::Cursor::setToLast ()
{ Boolean result = ivCollection->setToLast (*this);
  if (result)
    occurrence = ivCollection->elementAt (*this).occurrences;
  return result;
}

template <class Element, class ElementOps, class Base>
Boolean IWSrtBagOnKSSet <Element, ElementOps, Base>::Cursor::setToNext ()
{ if (occurrence == Base::Cursor::element().occurrences) {
    occurrence = 1;
    return Base::Cursor::setToNext ();
  }
  else {
    occurrence++;
    return True;
  }
}

template <class Element, class ElementOps, class Base>
Boolean IWSrtBagOnKSSet <Element, ElementOps, Base>::Cursor::setToPrevious ()
{ if (occurrence == 1) {
    occurrence = 1;
    Boolean result = Base::Cursor::setToPrevious ();
    if (result)
      occurrence = ivCollection->elementAt (*this).occurrences;
    return result;
  }
  else {
    occurrence--;
    return True;
  }
}

template <class Element, class ElementOps, class Base>
Boolean IWSrtBagOnKSSet <Element, ElementOps, Base>::
removePredicate (IBKSElm < Element > const& element, void* env)
{ RemoveEnv* re = (RemoveEnv*)env;
  re->removeCount += element.occurrences;
  return (*re->predicate) (element.elem, re->env);
}

template <class Element, class ElementOps, class Base>
Boolean IWSrtBagOnKSSet <Element, ElementOps, Base>::
cleanupPredicate (IBKSElm < Element > const& element, void* env)
{ return element.occurrences == 0;
}

template <class Element, class ElementOps, class Base>
ElementOps IWSrtBagOnKSSet <Element, ElementOps, Base>::
cvElementOps;
