#ifndef _ISIZEEVT_
#define _ISIZEEVT_
/*******************************************************************************
* FILE NAME: isizeevt.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IResizeEvent - resizing event class                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*$Log:   R:/IBMCLASS/IBASEAPP/VCS/ISIZEEVT.HPV  $                                                                         *
// 
//    Rev 1.3   25 Oct 1992 18:00:44   nunn
// Brad Broyles changes for external beta

      Rev 1.1   01 Jan 1989 12:00:00   LM & KKL
   Initiate code
      Rev 1.2   01 May 1991 12:00:00   KKL
   Combine all events into 1 file/modified for better performance
      Rev 1.3   01 Oct 1991 12:00:00   KKL
   Update per R2.0 spec.
      Rev 1.4   17 Sep 1992 12:00:00   KKL
   Make individual file
      Rev 1.5   22 Oct 1992 12:00:00   WBB
   Amend to match skeleton.hpp
*******************************************************************************/

// Forward declarations for other classes:
class IResizeEvent;
class ISize;
#if !defined( _IEVENT_ ) && !defined( I_NO_RELATED_HPP )
  #include <ievent.hpp>
#endif
#if !defined( _IPOINT_ ) && !defined( I_NO_RELATED_HPP )
  #include <ipoint.hpp>
#endif

class IResizeEvent  : public IEvent {
/*******************************************************************************
* The IResizeEvent class encapsulates the WM_SIZE message and provides         *
* functions to return the old and new sizes.                                   *
*******************************************************************************/
typedef IEvent Inherited;
public:
/*------------------------ CONSTRUCTORS/DESTRUCTORS ----------------------------
| There is one way to construct instances of this class:                       |
|   1. from an instance of the IEvent class                                    |
------------------------------------------------------------------------------*/
   IResizeEvent(IEvent& evt);

/*-------------------------------- ACCESSORS -----------------------------------
| These function provide means of getting and setting the accessible           |
| attributes of instances of this class:                                       |
|   oldSize - return the size before the window resize                         |
|   newSize - return the new window size                                       |
------------------------------------------------------------------------------*/
ISize
  oldSize() const,
  newSize() const;
}; // IResizeEvent

/*--------------------------------- INLINES ----------------------------------*/
#ifndef I_NO_INLINES
  #include <isizeevt.inl>
#endif

#endif /* _ISIZEEVT_ */
