#ifndef _ISYNONYM_
#define _ISYNONYM_
/*******************************************************************************
* FILE NAME: isynonym.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file declares synonyms for the types and values nested within         *
*   class IBase (see <ibase.hpp>).  #include-ing this file results in those    *
*   names be placed in the global name space, permitting consistent usage      *
*   in IBase derived classes and client code.                                  *
*                                                                              *
*   If these global names conflict with other usage of these names within      *
*   a client application, then this file should be modified for use in such    *
*   application.  For example, if you are using another library which          *
*   utilizes the typedef Boolean, then change "Boolean" below to something     *
*   like "IBoolean." "IBoolean" would then be used throughout your             *
*   application.                                                               *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*$Log:   R:/IBMCLASS/IBASE/VCS/ISYNONYM.HPV  $                                                                         *
//
//   Rev 1.1   25 Oct 1992 16:46:38   nunn
//changed library name to ICLUI
   
      Rev 1.0   12 Oct 1992 12:54:22   law
   Initial revision.
*******************************************************************************/
#ifndef _IBASE_
  #include <ibase.hpp>
#endif

typedef int Boolean;

typedef enum
  {
  false = IBase::false,
  true  = IBase::true
  };

#endif /* _ISYNONYM_ */
