#ifndef _ISYSMENU_
  #define _ISYSMENU_
/**************************************************************/
/* FILE NAME: isysmenu.hpp                                    */
/*                                                            */
/* DESCRIPTION:                                               */
/*    Declaration of the class:                               */
/*      ISystemMenu - wrapper for the System menu             */
/*                                                            */
/* COPYRIGHT:                                                 */
/*   Licensed Materials - Property of IBM                     */
/*   (c) Copyright IBM Corporation 1992, 1993                 */
/*   US Government Users Restricted Rights - Use duplication  */
/*   or disclosure restricted by GSA ADP Schedule Contract    */
/*   with IBM Corp.                                           */
/*                                                            */
/* $Log:   G:/IBMCLASS/IBASEAPP/VCS/ISYSMENU.HPV  $                                                      */
// 
//    Rev 1.2   26 Oct 1992 10:00:44   HARPERSP
// Updates for standardized header documentation.
/*                                                            */
/**************************************************************/

#ifndef _IMENU_
#include <imenu.hpp>
#endif

// Forward declarations for other classes
class  ISystemMenu;        /*  sysmn  */
class  IWindow;

class ISystemMenu : public IMenu
{
/**********************************************************************
* Creates an object that can be used to manipulate the System Menu.   *
*                                                                     *
* Example:                                                            *
*   ISystemMenu menu(myFrame);                                        *
*     The System Menu can now be manipulated using "menu"             *
*                                                                     *
* The member functions in IMenu and ISubMenu can be used to           *
* change the ISystemMenu. IMenuItem objects can be added to the       *
* ISystemMenu.                                                        *
**********************************************************************/
  public:
/*------------------ CONSTRUCTORS/DESTRUCTORS -------------------------
|  There is 1 way to construct instances of this class:               |
|    1. ISystemMenu(const IWindow* const owner);                      |
|                                                                     |
---------------------------------------------------------------------*/
     ISystemMenu(const IWindow* const owner);


/*----------------------- PRIVATE -----------------------------------*/
  private:
    const IWindow* pwndClOwner;
};
#endif  /* _ISYSMENU_ */
