#ifndef __io_h
   #define __io_h

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <io.h> header file                                              */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C Set/2 Beta Version                                        */
   /*  Copyright (C) International Business Machines Corp., 1991,1992  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #if ( defined(__SPC__) || defined(__EXTENDED__) )

      int  _Optlink _access( const char *, int );
      int  _Optlink _chmod( const char *, int );
      int  _Optlink _chsize( int, long );
      int  _Optlink _close( int );
      int  _Optlink _creat( const char *, int );
      int  _Optlink _dup( int );
      int  _Optlink _dup2( int, int );
      int  _Optlink _eof( int );
      long _Optlink _filelength( int );
      int  _Optlink _isatty( int );
      long _Optlink _lseek( int, long, int );
      int  _Optlink _open( const char *, int, ... );
      int  _Optlink _read( int, void *, unsigned int );
      int  _Optlink remove( const char * );
      int  _Optlink rename( const char *, const char * );
      int  _Optlink _sopen( const char *, int, int, ... );
      long _Optlink _tell( int );
      int  _Optlink _umask( int );
      #ifdef __cplusplus
         int  _Optlink _unlink( const char * );
      #else
         int  _Optlink _unlink( char * );
      #endif
      int  _Optlink _write( int, const void *, unsigned int );
      int  _Optlink _setmode(int handle, int mode);

      #ifdef __cplusplus

         inline   int  _Optlink access( const char * a, int b)                  { return _access(a,b);   }
         inline   int  _Optlink chmod( const char * a, int b)                   { return _chmod(a,b);    }
         inline   int  _Optlink chsize( int a, long b)                          { return _chsize(a,b);   }
         inline   int  _Optlink close( int a)                                   { return _close(a);      }
         inline   int  _Optlink creat( const char * a, int b)                   { return _creat(a,b);    }
         inline   int  _Optlink dup( int a)                                     { return _dup(a);        }
         inline   int  _Optlink dup2( int a, int b)                             { return _dup2(a,b);     }
         inline   int  _Optlink eof( int a )                                    { return _eof(a);        }
         inline   long _Optlink filelength( int a)                              { return _filelength(a); }
         inline   int  _Optlink isatty( int a)                                  { return _isatty(a);     }
         inline   long _Optlink lseek( int a, long b, int c)                    { return _lseek(a,b,c);  }
         inline   int  _Optlink read( int a, void * b, unsigned int c)          { return _read(a,b,c);   }
         inline   long _Optlink tell( int a)                                    { return _tell(a);       }
         inline   int  _Optlink umask( int a)                                   { return _umask(a);      }
         #ifndef __unlink__
            #define __unlink__
            inline   int  _Optlink unlink( const char * a)                      { return _unlink(a);     }
         #endif
         inline   int  _Optlink write( int a, const void * b, unsigned int c)   { return _write(a,b,c);  }
         inline   int  _Optlink setmode(int a, int b)                           { return _setmode(a,b);  }

         /*******************/
         /* Temporary fixes */
         /*******************/

         int  _Optlink open( const char *, int, ... );
         int  _Optlink sopen( const char *, int, int, ... );

      #else

         #define  access( a,b )      _access( (a),(b) )
         #define  chmod( a,b )       _chmod( (a),(b) )
         #define  chsize( a,b )      _chsize( (a),(b) )
         #define  close( a )         _close( a )
         #define  creat( a,b )       _creat( (a),(b) )
         #define  dup( a )           _dup( a )
         #define  dup2( a,b )        _dup2( (a),(b) )
         #define  eof( a )           _eof( a )
         #define  filelength( a )    _filelength( a )
         #define  isatty( a )        _isatty( a )
         #define  lseek( a,b,c )     _lseek( (a),(b),(c) )
         #define  open               _open
         #define  read( a,b,c )      _read( (a),(b),(c) )
         #define  sopen              _sopen
         #define  tell( a )          _tell( a )
         #define  umask( a )         _umask( a )
         #ifndef unlink
            #define unlink           _unlink
         #endif
         #define  write( a,b,c )     _write( (a),(b),(c) )
         #define  setmode( a,b )     _setmode( (a),(b) )

      #endif

   #endif

   #ifdef __cplusplus
      }
   #endif

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )

#endif
