#ifndef __limits_h
   #define __limits_h

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <limits.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C Set/2 Beta Version                                        */
   /*  Copyright (C) International Business Machines Corp., 1991,1992  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #define CHAR_BIT      8

   #define SCHAR_MIN     (-128)
   #define SCHAR_MAX     127
   #define UCHAR_MAX     255

   #ifdef _CHAR_UNSIGNED
      #define CHAR_MIN      0
      #define CHAR_MAX      UCHAR_MAX
   #else
      #define CHAR_MIN      SCHAR_MIN
      #define CHAR_MAX      SCHAR_MAX
   #endif

   #define MB_LEN_MAX    2

   #define SHRT_MIN      (-32768)
   #define SHRT_MAX      32767
   #define USHRT_MAX     65535

   #define INT_MIN       (-2147483647 - 1)
   #define INT_MAX       2147483647
   #define UINT_MAX      0xffffffff          /* 4294967295  */

   #define LONG_MIN      (-2147483647L - 1)
   #define LONG_MAX      2147483647
   #define ULONG_MAX     0xffffffff          /* 4294967295U */

   #ifdef __cplusplus
      }
   #endif

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )

#endif
