#ifndef __process_h
   #define __process_h

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <process.h> header file                                         */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C Set/2 Beta Version                                        */
   /*  Copyright (C) International Business Machines Corp., 1991,1992  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #if defined(__EXTENDED__)

      /* Modeflag values for spawnxx routines */

      #define P_WAIT          0
      #define P_NOWAIT        1
      #define P_OVERLAY       2

      /* Action codes used with cwait() */

      #define WAIT_CHILD      0
      #define WAIT_GRANDCHILD 1

      /* function prototypes */

      int  _Optlink _execl_ansi( char *, char *, ... );
      int  _Optlink _execle_ansi( char *, char *, ... );
      int  _Optlink _execlp_ansi( char *, char *, ... );
      int  _Optlink _execlpe_ansi( char *, char *, ... );
      void _Optlink _exit( int );
      int  _Optlink _spawnl_ansi( int, char *, char *, ... );
      int  _Optlink _spawnle_ansi( int, char *, char *, ... );
      int  _Optlink _spawnlp_ansi( int, char *, char *, ... );
      int  _Optlink _spawnlpe_ansi( int, char *, char *, ... );
      void _Optlink abort( void );
      int  _Optlink _cwait( int *, int, int );
      int  _Optlink _execv( char *, char ** );
      int  _Optlink _execve( char *, char **, char ** );
      int  _Optlink _execvp( char *, char ** );
      int  _Optlink _execvpe( char *, char **, char ** );
      void _Optlink exit( int );
      int  _Optlink _getpid( void );
      int  _Optlink _spawnv( int, char *, char ** );
      int  _Optlink _spawnve( int, char *, char **, char ** );
      int  _Optlink _spawnvp( int, char *, char ** );
      int  _Optlink _spawnvpe( int, char *, char **, char ** );
      int  _Optlink _system( const char * );
      int  _Optlink _wait( int * );

      #ifdef __cplusplus
         int  inline _Optlink cwait(int *a, int b, int c )                   {  return _cwait( a, b, c );        }
         int  inline _Optlink execv( char *a, char **b )                     {  return _execv( a, b );           }
         int  inline _Optlink execve( char *a, char **b, char **c )          {  return _execve( a, b, c );       }
         int  inline _Optlink execvp( char *a, char **b )                    {  return _execvp( a, b );          }
         int  inline _Optlink execvpe( char *a, char **b, char **c )         {  return _execvpe( a, b, c );      }
         int  inline _Optlink getpid()                                       {  return _getpid();                }
         int  inline _Optlink spawnv( int a, char *b, char **c )             {  return _spawnv( a, b, c );       }
         int  inline _Optlink spawnve( int a, char *b, char **c, char **d )  {  return _spawnve( a, b, c, d );   }
         int  inline _Optlink spawnvp( int a, char *b, char **c )            {  return _spawnvp( a, b, c );      }
         int  inline _Optlink spawnvpe( int a, char *b, char **c, char **d ) {  return _spawnvpe( a, b, c , d ); }
         int  inline _Optlink system( const char *a )                        {  return _system( a );             }
         int  inline _Optlink wait( int *a )                                 {  return _wait( a );               }
      #else
         #define  cwait( a, b, c )         _cwait( (a),(b),(c) )
         #define  execv( a, b )            _execv( (a),(b) )
         #define  execve( a, b, c )        _execve( (a),(b),(c) )
         #define  execvp( a, b )           _execvp( (a),(b) )
         #define  execvpe( a, b, c )       _execvpe( (a),(b),(c) )
         #define  getpid                   _getpid
         #define  spawnv( a, b, c )        _spawnv( (a),(b),(c) )
         #define  spawnve( a, b, c, d )    _spawnve( (a),(b),(c),(d) )
         #define  spawnvp( a, b, c )       _spawnvp( (a),(b),(c) )
         #define  spawnvpe( a, b, c , d )  _spawnvpe( (a),(b),(c),(d) )
         #define  system( a )              _system( a )
         #define  wait( a )                _wait( a )
      #endif

      #ifdef __MULTI__
         int  _Optlink _beginthread( void ( * _Optlink __thread )( void * ), void *, unsigned, void * );
         void _Optlink _endthread( void );
         void ** _Optlink _threadstore( void );
      #endif

      #pragma info( none )
      int _Optlink _execl( );
      int _Optlink _execle( );
      int _Optlink _execlp( );
      int _Optlink _execlpe( );
      int _Optlink _spawnl( );
      int _Optlink _spawnle( );
      int _Optlink _spawnlp( );
      int _Optlink _spawnlpe( );

      #define _execl    _execl_ansi
      #define _execle   _execle_ansi
      #define _execlp   _execlp_ansi
      #define _execlpe  _execlpe_ansi
      #define _spawnl   _spawnl_ansi
      #define _spawnle  _spawnle_ansi
      #define _spawnlp  _spawnlp_ansi
      #define _spawnlpe _spawnlpe_ansi

      #define execl    _execl_ansi
      #define execle   _execle_ansi
      #define execlp   _execlp_ansi
      #define execlpe  _execlpe_ansi
      #define spawnl   _spawnl_ansi
      #define spawnle  _spawnle_ansi
      #define spawnlp  _spawnlp_ansi
      #define spawnlpe _spawnlpe_ansi
      #pragma info( restore )

   #endif

   #ifdef __cplusplus
      }
   #endif

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )

#endif
