#ifndef __search_h
   #define __search_h

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <search.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C Set/2 Beta Version                                        */
   /*  Copyright (C) International Business Machines Corp., 1991,1992  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #ifndef __size_t
     #define __size_t
     typedef unsigned int size_t;
   #endif

   /* function prototypes */

   char * _Optlink _lsearch( const char *, const char *, unsigned int *,
                            unsigned int, int ( * _Optlink __compare )( const void *, const void * ) );
   char * _Optlink _lfind( const char *, const char *, unsigned int *,
                          unsigned int, int ( * _Optlink __compare )( const void *, const void * ) );
   void * _Optlink bsearch( const void *, const void *, size_t, size_t,
                            int ( * _Optlink __compare )( const void *, const void * ) );
   void   _Optlink qsort( void *, size_t, size_t,
                          int ( * _Optlink __compare )( const void *, const void * ) );

   #if defined(__EXTENDED__)

      #pragma info( none )
      #define  lsearch(a,b,c,d,e)   _lsearch((a),(b),(c),(d),(e))
      #define  lfind(a,b,c,d,e)     _lfind((a),(b),(c),(d),(e))
      #pragma info( restore )

   #endif

   #ifdef __cplusplus
      }
   #endif

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )

#endif
