#ifndef __stdarg_h
   #define __stdarg_h

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <stdarg.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C Set/2 Beta Version                                        */
   /*  Copyright (C) International Business Machines Corp., 1991,1992  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   typedef char *va_list;

   #define __nextword(base)   (((unsigned)(sizeof(base))+3U)&~(3U))

   #define va_start(ap, last) ap = ((va_list)&last) + __nextword(last)
   #define va_arg(ap, type)   ((type *) ((ap += (int) __nextword(type)) - __nextword(type)))[0]
   #ifdef __cplusplus
     #define va_end(ap)         ap = 0
   #else
     #define va_end(ap)         ap = (void *) 0
   #endif


   #ifdef __cplusplus
      }
   #endif

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )

#endif
