#ifndef __string_h
   #define __string_h

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <string.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C Set/2 Beta Version                                        */
   /*  Copyright (C) International Business Machines Corp., 1991,1992  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #ifndef __size_t
      #define __size_t
      typedef unsigned int size_t;
   #endif

   #ifndef NULL
      #if (defined(__EXTENDED__)  || defined( __cplusplus ))
         #define NULL 0
      #else
         #define NULL ((void *)0)
      #endif
   #endif

   char * _Builtin __strcat( char *, const char * );
   char * _Builtin __strchr( const char *, int );
   int    _Builtin __strcmp( const char *, const char * );
   char * _Builtin __strcpy( char*, const char * );
   size_t _Builtin __strlen( const char * );
   char * _Builtin __strncat( char *, const char *, size_t );
   int    _Builtin __strncmp( const char *, const char *, size_t );
   char * _Builtin __strncpy( char *, const char *, size_t );
   char * _Builtin __strrchr( const char *, int );
   char * _Optlink strcat( char *, const char * );
   char * _Optlink strchr( const char *, int );
   int    _Optlink strcmp( const char *, const char * );
   char * _Optlink strcpy( char*, const char * );
   size_t _Optlink strlen( const char * );
   char * _Optlink strncat( char *, const char *, size_t );
   int    _Optlink strncmp( const char *, const char *, size_t );
   char * _Optlink strncpy( char *, const char *, size_t );
   char * _Optlink strrchr( const char *, int );
   int    _Optlink strcoll( const char *, const char * );
   size_t _Optlink strcspn( const char *, const char * );
   char * _Optlink strerror( int );
   char * _Optlink strpbrk( const char *, const char * );
   size_t _Optlink strspn( const char *, const char * );
   char * _Optlink strstr( const char *, const char * );
   char * _Optlink strtok( char*, const char * );
   size_t _Optlink strxfrm( char *, const char *, size_t );

   #ifndef __cplusplus
      #pragma info( none )
      #define strcat( x, y )     __strcat( (x), (y) )
      #define strchr( x, y )     __strchr( (x), (y) )
      #define strcmp( x, y )     __strcmp( (x), (y) )
      #define strcpy( x, y )     __strcpy( (x), (y) )
      #define strlen( x )        __strlen( (x) )
      #define strncat( x, y, z ) __strncat( (x), (y), (z) )
      #define strncmp( x, y, z ) __strncmp( (x), (y), (z) )
      #define strncpy( x, y, z ) __strncpy( (x), (y), (z) )
      #define strrchr( x, y )    __strrchr( (x), (y) )
      #pragma info( restore )
   #endif

   #ifndef __memory_h
      #define __memory_h

      /*
       *   __memcpy is predeclared in the C++ compiler do not redeclare it
       */

      #ifndef __cplusplus
         void * _Builtin __memcpy( void *, const void *, size_t );
      #endif

      void * _Builtin __memchr( const void *, int, size_t );
      int    _Builtin __memcmp( const void *, const void *, size_t );
      void * _Builtin __memset( void *, int, size_t );
      void * _Builtin __memmove( void *, const void *, size_t );

      void * _Optlink memcpy( void *, const void *, size_t );
      void * _Optlink memchr( const void *, int, size_t );
      int    _Optlink memcmp( const void *, const void *, size_t );
      void * _Optlink memset( void *, int, size_t );
      void * _Optlink memmove( void *, const void *, size_t );

      #ifndef __cplusplus
         #pragma info( none )
         #define memcpy( x, y, z )  __memcpy( (x), (y), (z) )
         #define memchr( x, y, z )  __memchr( (x), (y), (z) )
         #define memcmp( x, y, z )  __memcmp( (x), (y), (z) )
         #define memset( x, y, z )  __memset( (x), (y), (z) )
         #define memmove( x, y, z ) __memmove( (x), (y), (z) )
         #pragma info( restore )
      #endif

      #if  defined( __EXTENDED__ )

         void * _Optlink memccpy( void *, void *, int, unsigned int );
         int    _Optlink memicmp( void *, void *, unsigned int );

         #pragma info( none )
         #define _fmemcpy( x, y, z )     memcpy( (x), (y), (z) )
         #define _fmemchr( x, y, z )     memchr( (x), (y), (z) )
         #define _fmemcmp( x, y, z )     memcmp( (x), (y), (z) )
         #define _fmemset( x, y, z )     memset( (x), (y), (z) )
         #define _fmemccpy( w, x, y, z ) memccpy( (w), (x), (y), (z) )
         #define _fmemicmp( x, y, z )    memicmp( (x), (y), (z) )
         #pragma info( restore )

      #endif

   #endif

   #if defined(__EXTENDED__)

      char * _Optlink strdup( const char * );
      int    _Optlink stricmp( const char *, const char * );
      char * _Optlink strlwr( char * );
      int    _Optlink strnicmp( const char *, const char *, size_t );
      char * _Optlink strupr( char * );


      int    _Optlink strcmpi( const char *, const char * );
      char * _Optlink strrev( char * );
      char * _Optlink strset( char *, int );
      char * _Optlink strnset( char *, int, size_t );
      char * _Optlink _strerror( char * );

      #define _fmemmove( x, y, z )  memmove( (x), (y), (z) )
      #define _fstrcmp( x, y )      strcmp( (x), (y) )
      #define _fstrlen( x )         strlen( (x) )
      #define _fstrcpy( x, y )      strcpy( (x), (y) )
      #define _fstrcat( x, y )      strcat( (x), (y) )
      #define _fstrchr( x, y )      strchr( (x), (y) )
      #define _fstrrchr( x, y )     strrchr( (x), (y) )
      #define _fstrstr( x, y )      strstr( (x), (y) )
      #define _fstrspn( x, y )      strspn( (x), (y) )
      #define _fstrtok( x, y )      strtok( (x), (y) )
      #define _fstrset( x, y )      strset( (x), (y) )
      #define _fstrlwr( x )         strlwr( (x) )
      #define _fstrupr( x )         strupr( (x) )
      #define _fstrdup( x )         strdup( (x) )
      #define _fstrrev( x )         strrev( (x) )
      #define _fstrncat( x, y, z )  strncat( (x), (y), (z) )
      #define _fstrpbrk( x, y )     strpbrk( (x), (y) )
      #define _fstrnset( x, y, z )  strnset( (x), (y), (z) )
      #define _fstrncmp( x, y, z )  strncmp( (x), (y), (z) )
      #define _fstrncpy( x, y, z )  strncpy( (x), (y), (z) )
      #define _fstricmp( x, y )     stricmp( (x), (y) )
      #define _fstrcspn( x, y )     strcspn( (x), (y) )
      #define _fstrnicmp( x, y, z ) strnicmp( (x), (y), (z) )
      #define _nstrdup( x )         strdup( (x) )

   #endif

   #ifdef __cplusplus
      }
   #endif

   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )

#endif
