/* Copyright (c) IBM Corp. 1992 */
#include <iglobals.h>
#include <string.h>

#include <iset.h>

class Ingredient {
	char* name;
public:
	Ingredient(char* n) {
		name= n;
	}
	char* getName() const {
		return (name);
	}
	Boolean operator== (Ingredient const& i) const{
		return!(strcmp(name, i.getName()));
	}
	Boolean operator< (Ingredient const& i) const{
		return strcmp(name, i.getName())<0;
	}
	friend unsigned long hash (Ingredient const& i, unsigned long n) {
		return hash(i.getName(), n);
	}
};



typedef ISet <Ingredient> IngSet;

class Cocktail {
	char* name;
	IngSet ingredients;
	Boolean make;
public:
	Cocktail(char* n) {
		name= n;
		make= True;
	}
	char* getName() const {
		return (name);
	}
	IngSet const& getIngredients() const {
		return(ingredients);
	}
	void setMake(Boolean m) {
		make= m;
	}
	Boolean getMake() const {
		return(make);
	}
	void addIngredient(Ingredient const & i) {
		ingredients.add(i);
	}
	Boolean operator==(Cocktail const& c) const {
		return!(strcmp(name, c.getName()));
	}
	Boolean operator<(Cocktail const& c) const {
		return strcmp(name, c.getName())<0;
	}
	friend unsigned long hash (Cocktail const& c, unsigned long n) {
		return hash(c.getName(), n);
	}
};
