/* Copyright (c) IBM Corp. 1992 */
#ifndef _IKEYELEM_H
#define _IKEYELEM_H

#include <stdlib.h>
#include <iglobals.h>
#include <iostream.h>
#include <istdops.h>

class TestElement {
    int i;
    int j;
public:
  TestElement () : i(0), j(0) {}
  TestElement (int i,int j) : i (i), j(j) {}
  operator int () const {return i;}

  Boolean operator == (TestElement const& k) const
  { return i == k.i && j == k.j; }

  Boolean operator < (TestElement const& k) const
  { return i < k.i || (i == k.i && j < k.j); }

  friend unsigned long hash (TestElement const& k, unsigned long n)
  { return k.i % n; }

  int const & geti() const { return i;}
  int const & getj() const {return j;} 
};


ostream & operator << (ostream &sout, TestElement const& e) {
  sout << e.geti() << "," << e.getj() ;
  return sout;
}
// NOTE: You MUST return  a const & in the key function
// otherwise you are returning a reference to a temporary
int const& key (TestElement const& k) {return k.geti();}

#endif
