/* Copyright (c) IBM Corp. 1992 */
#include "parcel.h"

#include <isrtmap.h>
#include <iostream.h>

ostream& operator<<(ostream& s, Parcel p) {
	if (p.now().getPlace()!=p.dest().getPlace()) {
		return s<< p.getID()<<": From "<<p.orig().getPlace()<<"("<<p.orig().getTime()<<") to "<<p.dest().getPlace()<<" is now at "<<p.now().getPlace()<<"("<<p.now().getTime()<<")";
	}
	else {
		return s<<p.getID()<<": From "<<p.orig().getPlace()<<"("<<p.orig().getTime()<<") to "<<p.now().getPlace()<<"("<<p.now().getTime()<<") delivered.";
	}
}

typedef ISortedMap<Parcel, char*> ParcelService;

void list(ParcelService const& p);

void update(ParcelService const& p, ParcelService& d);

main() {

	ParcelService ps;
	ParcelService delivered;
	
	ps.add(Parcel("Lobito", "Athen", 26.02, "26LoAt"));
	ps.add(Parcel("Angusta", "Canberra", 27.02, "27AnCa"));
	ps.add(Parcel("Wassenaar", "Shinagawa", 25.02, "25WaSh"));
	ps.add(Parcel("Kanpur", "Uster", 25.03, "25KaUs"));
	update(ps, delivered);
	list(ps);

	ps.elementWithKey("26LoAt").arrivedAt("Luanda", 28.02);
	ps.elementWithKey("27AnCa").arrivedAt("Atlanta", 28.02);
	ps.elementWithKey("25WaSh").arrivedAt("Amsterdam", 25.02);
	ps.elementWithKey("25KaUs").arrivedAt("Delhi", 25.03);
	update(ps, delivered);
	list(ps);

	ps.elementWithKey("26LoAt").arrivedAt("Athen", 28.02);
	ps.elementWithKey("25KaUs").arrivedAt("Zuerich", 26.03);
	update(ps, delivered);
	list(ps);
	list(delivered);
	
	ps.removeElementWithKey("26LoAt");

	ps.add(Parcel("Kanpur", "Uster", 27.04, "27KaUs"));
	ps.add(Parcel("Wassenaar","Shinagawa", 15.02, "25WaSh"));
	ps.elementWithKey("25KaUs").arrivedAt("Uster", 29.03);
	update(ps, delivered);
	list(ps);


	ParcelService::Cursor pscursor(ps);

	for (pscursor.setToFirst(); pscursor.isValid(); pscursor.setToNext()) {
		ps.elementAt(pscursor).arrivedAt(ps.elementAt(pscursor).dest().getPlace(), 30.02);
	}
	update(ps, delivered);
	list(ps);
	if (delivered.containsAllFrom(ps)) {
		cout<<"All delivered \n";
	}
	else {
		cout<<"Something very wrong is happening here \n";
	}
        return 0;
}


void list(ParcelService const& p) {
	ParcelService::Cursor pcursor(p);
	for(pcursor.setToFirst(); pcursor.isValid(); pcursor.setToNext()) {
		cout<<p.elementAt(pcursor)<<"\n";
	}
	cout<<"\n";
}

void update(ParcelService const& p, ParcelService& d) {
	ParcelService::Cursor pc(p);
	
	for (pc.setToFirst(); pc.isValid(); pc.setToNext()) {
		if (!d.contains(p.elementAt(pc))) {
			if (p.elementAt(pc).now().getPlace()==p.elementAt(pc).dest().getPlace()) {
				d.add(p.elementAt(pc));
			}
		}
	}
} 
