/* Copyright (c) IBM Corp. 1992 */
#include "iseq.h"
#include <iostream.h>
#include "xseq2.h"

typedef ISequence <Word> WordSeq;
typedef IIterator <Word> WordIter;

long compare ( Word const& w1, Word const& w2) {
	return(strcmp(w1.getElement(), w2.getElement()));
}


/*--------------------------------------------------------------------------*\ 
* Test variables                                                             *
\*--------------------------------------------------------------------------*/

char *String[9] = {
   "the",
   "quick",
   "brown",
   "fox",
   "jumps",
   "over",
   "a",
   "lazy",
   "dog"
};

class PrintClass : public WordIter
{
public:
   Boolean applyTo(Word &w)
      {
      cout << "\n" << w.getElement();    // Print the string
      return(True);
      }
};




/*--------------------------------------------------------------------------*\ 
* Main program                                                               *
\*--------------------------------------------------------------------------*/
int main()
{
   WordSeq WL;
   Word     aWord;
   WordSeq:: Cursor cursor(WL);
   PrintClass Print;

   int i;

   cout << "\n*** Example of Sequence use ***\n";

   for (i = 0; i < 9; i ++) {                // Put all strings in the list
      aWord.fill(String[i]);                 // Fill object with right value
      WL.addAsFirst(aWord);                  // Add it as first in the list
      }
   cout << "\nList initial order:\n";        // Print the list in this order
   WL.allElementsDo(Print);
   
   WL.sort(compare);                       // Sort the list ascending
   cout << "\nList sorted order:\n";         // Print the list in this order
   WL.allElementsDo(Print);

   // demonstrate iteration via cursor
   cout << "\nLook for \"fox\" in the list\n";
   for (cursor.setToFirst(); cursor.isValid() && (WL.elementAt(cursor) != "fox"); cursor.setToNext());

   if (WL.elementAt(cursor)== "fox") {
	cout << "\n found Element \n";
    }
   else {
	cout << "\n Element not found \n";
   }


   cout << "\n*** End of example ***\n";

   return(0);
}

