/**************************************************************/
/* Menu Test Program for IAccelerator                         */
/*                       IMenu                                */
/*                       IActionBarMenu                       */
/*                       IPopUpMenu                           */
/*                       ISystemMenu                          */
/*                       IMenuItem                            */
/*                       ITitle                               */
/*                                                            */
/* CHANGE ACTIVITY:                                           */
/*   DATE:     INITIAL:        DESCRIPTION                    */
/*                                                            */
/*   071882    Peter Hoa       Initial  code                  */
/*   090192    SPH             Changes for Driver 3           */
/**************************************************************/
#include <iframe.hpp>
#include <iapp.hpp>
#include <irect.hpp>
#include <ievtres.hpp>
#include <ievent.hpp>
#include <icmdhdr.hpp>
#include <imenuhdr.hpp>

#include <iaccel.hpp>
#include <imnitem.hpp>
#include <imenu.hpp>
#include <iabmenu.hpp>
#include <isysmenu.hpp>
#include <ititle.hpp>

#include <ipoint.hpp>
#include <istattxt.hpp>
#include <ientryfd.hpp>
#include <istring.hpp>
#include <ireslib.hpp>

#include <iiconctl.hpp>
#include <ipopmenu.hpp>
#include <isubmenu.hpp>

class TestWindow;

class EFPopUpHandler : public IMenuHandler
{
   friend class TestWindow;

   public:

      EFPopUpHandler();

   protected:

      IPopUpMenu* makePopUpMenu(const IMenuEvent& mnEvt);

      void menuShowing(const IMenuEvent& mnEvt,
                       ISubMenu* psmnAboutToShow);

      void menuSelected(const IMenuEvent& mnEvt);

   private:
      IEntryField::Alignment alignment;
};

class TestWindow : public IFrameWindow, 
                   public ICommandHandler,
                   public IMenuHandler

{

   public:

      TestWindow( unsigned long windowId, const IWindow* parentWindow,
                const IWindow* ownerWindow, const IRectangle& initialSize);

      ~TestWindow();

       Boolean defaultABMActive() {return defaultABMActive_;}

   protected:

      Boolean command(ICommandEvent& cmdevt);
      IPopUpMenu* makePopUpMenu(const IMenuEvent& mnEvt);
      void menuShowing(const IMenuEvent& mnEvt,
                       ISubMenu* psmnAboutToShow);


   private:

      IResourceLibrary      resmgr_exe;  // must be first so it's initialized first
      ITitle            tle;
      IAccelerator      ac;
      IAccelerator      ac_title;
      IActionBarMenu    abmn;
      ISystemMenu       sysmn;

      IPopUpMenu*       ppumn;  // moved here so it's initialized before used

      IIconControl      ic_doc;
      IIconControl      ic_hr;
      IIconControl      ic_inbasket;
      IIconControl      ic_folder;

      IMenuItem         mni_text1;
      IMenuItem         mni_text2;
      IMenuItem         mni_text3;
      IMenuItem         mni_system;
      IMenuItem         mni_popup;

      IMenuItem         mni_bitmap;
      IMenuItem         mni_bitmap2;
      IMenuItem         mni_bitmap5;
      IMenuItem         mni_popup_bitmap;

      IStaticText*      psttxt;

      IEntryField*      pef;
      EFPopUpHandler    efpuHandler;


      IMenuItem         mni_AltABM;
      IMenuItem         mni_DefABM;
      Boolean           defaultABMActive_;
};

