/**************************************************************************/
/* Sample Program for IBMCLASS - Classes definitions                      */
/*                                                                        */
/* Change History:                                                        */
/* Rel Programmer        Stamp Date     Description                       */
/* --- ----------------- ----- -------- --------------------------------- */
/* 2.0 Kevin Leong       KKL   30/12/91 Creation                          */
/* 3.0 Kevin Leong       KKL   01/08/92 Modify for V3.0 classes           */
/* 3.1 Philippe Gregoire PHG   10/09/92 Add more stuff for demo           */
/**************************************************************************/

// include IBMCLASS headers
#include <iframe.hpp>           // IFrameWindow
//#include <ifillbox.hpp>         // IFillBox
#include <istattxt.hpp>         // IStaticText
#include <ilistbox.hpp>         // IListBox
#include <ibmpctl.hpp>          // IBitmapControl
#include <icmdhdr.hpp>          // ITheCommand, ICommandHandler
#include <iabmenu.hpp>          // IActionBarMenu

// include Client class headers
#include "wincl.hpp"


/**************************************************************************/
/* Class:   MyWindow                                                      */
/*                                                                        */
/* Purpose: This is the sample application's main window                  */
/*          It is a subclass of IFrameWindow                              */
/*                                                                        */
/* Change History:                                                        */
/* Rel Programmer        Stamp Date     Description                       */
/* --- ----------------- ----- -------- --------------------------------- */
/* 2.0 Kevin Leong       KKL   10/09/92 Creation                          */
/* 3.1 Philippe Gregoire PHG   10/09/92 Added frame extensions            */
/**************************************************************************/
class MyWindow : public IFrameWindow, public ICommandHandler
{
  public:
    // Constructor
    MyWindow(unsigned long windowId);

  protected:
    Boolean command(ICommandEvent&);

  private:
    // define our instance variables
    MyClientWindow*  pMyClient;     // Client area
    IStaticText*     psttxtStatus;  // static text, top of client (status area)
    IListBox*        plbCustList;   // list box of customers
    IBitmapControl*  pbcTBIcon;     // TitleBar icon
    IDragSourceHandler* psrchTBIcon;    // dragsource handler for TB icon

    IActionBarMenu*  pabmnMain;     // Main menu
};
