/**************************************************************************/
/* Sample Program for IBMCLASS - Client Classes definition                */
/*                                                                        */
/* Change History:                                                        */
/* Rel Programmer        Stamp Date     Description                       */
/* --- ----------------- ----- -------- --------------------------------- */
/* 3.1 Philippe Gregoire PHG   10/09/92 Creation for demo                 */
/**************************************************************************/

/* include IBMCLASS headers */
#include <ifillbox.hpp>         // IFillBox
#include <istattxt.hpp>         // IStaticText
#include <ientryfd.hpp>         // IEntryField
#include <igroupbx.hpp>         // IGroupBox

/**************************************************************************/
/* Class:   MyWindowClient                                                */
/*                                                                        */
/* Purpose: This is the sample application's client window                */
/*          It is a subclass of IFillBox                                  */
/*                                                                        */
/* Change History:                                                        */
/* Rel Programmer        Stamp Date     Description                       */
/* --- ----------------- ----- -------- --------------------------------- */
/* 3.1 Philippe Gregoire PHG   10/09/92 Creation                          */
/**************************************************************************/
//class MyClientWindow : public IFillBox
class MyClientWindow : public IStaticText
{
  public:
    // Constructor
    MyClientWindow(unsigned long windowId, const IWindow* parentownerWindow);

    // method to read switch client from resource
    IString nextCustomer();
    IString previousCustomer();
    long    currentCustomer() { return(lCurCustomer); };

  private:
    // private functions
    long setCustomer(long lCustomer);
    IString statCust() const;

    // define our instance variables
    IStaticText*     psttxtName;    // name label
    IEntryField*     pefName;       // name entryfield
    IStaticText*     psttxtNumber;  // number label
    IEntryField*     pefNumber;     // number entryfield
    IGroupBox*       pgbxAddress;   // address groupbox
    IStaticText*     psttxtAddress; // address label
    IEntryField*     pefAddress;    // address entryfield
    IStaticText*     psttxtState;   // state label
    IEntryField*     pefState;      // state entryfield
    IStaticText*     psttxtZip;     // zipcode label
    IEntryField*     pefZip;        // zipcode entryfield

    long             lCurCustomer;  // Current Customer

};
