.*************************************************************************
.* PMSPY Help text                                                       *
.*                                                                       *
.*  COPYRIGHT:                                                           *
.*  ----------                                                           *
.*  Copyright (C) International Business Machines Corp., 1991,1992.      *
.*                                                                       *
.*************************************************************************
.*--- This macro is the trick to use the C preprocessor to substitute ---
.*--- the defined constants in the .h files -----------------------------
#define res(x) res= ## x ##.
.*--- Load values for symbolic substitutions as needed ---
#include "pmspyipf.h"
#include "pmspyrc.h"
.*--------------------------------------------------------------------------
#define AGENTS 8
.*--------------------------------------------------------------------------
:userdoc.
.*************************************************************************
.* PMSPY - General Help
.*************************************************************************
.*
.*
.*************************************************************************
:h1 res(PID_EXTHELP)Extended Help
.*************************************************************************
.*
.* Load all :i1 items one time
.*
.*************************************************************************
.* Top Level INDEX items
.*
.* - defined only ONCE here, but referenced many times in other panels
.*************************************************************************
:i1 id=iDLG.   Dialogs
:i1 id=iHOWTO. How do I?
:i1 id=iLIST.  Message list
:i1 id=iLOG.   Log file
:i1 id=iMsg.   Messages
:i1 id=iMSGFIL.Message filtering
:i1 id=iPRO.   Profile file
:i1 id=iPRODEF.Default profile file
:i1 id=iSPY.   PMSPY
.*
:hp4.PMSPY:ehp4. allows you to :hp3.spy:ehp3.
on the messages that are :hp3.posted:ehp3. or :hp3.sent:ehp3.
to visible or invisible (OBJECT) windows through message queues.
This includes the messages that PM sends as well as any internal
application messages that may be used.
.*
:p.It is an excellent learning tool for PM programming because it visibly
demonstrates PM&apos.s message based operation.
It also excels as a PM debugging tool because:
:ul compact.
:li.No additional coding is necessary in the application
:li.It may be started before or while the application is running
:li.Up to AGENTS different :hp3.agents:ehp3. may be active
at once allowing for the debugging of
complex inter-window, intra-window, multi-threaded, or OBJECT window
applications
:eul.
.*
:p.Basic operations and features include:
:ol compact.
:li.Simple :hp3.point and shoot:ehp3. selection of visible windows
.*
:li.You can select
:link reftype=hd res(ID_AB_SPYON)who:elink.
and/or
:link reftype=hd res(ID_AB_SPYWHAT)what:elink.
you want to :hp3.spy:ehp3.
.*
:li.A
:link reftype=hd res(ID_AB_FILTER)filtering:elink. mechanism allows
you to include or suppress individual or
groups of messages.
.*
:li.The filtering mechanism can be totally user definable by using a
:link reftype=hd res(PID_R_PROFILE)profile:elink..
.*
:li.A
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink.
is automatically provided for :hp2.out-of-the-box:ehp2. operation.
.*
:li.Messages may optionally be logged to a
:link reftype=hd res(PID_R_LOG_FILE)log file:elink..
.*
:eol.
.*
:p.Other thing you may be interested in:
:ol compact.
.*
:li.:link reftype=hd res(PID_HOWTO)How do I do it?:elink.
:li.:link reftype=hd res(PID_SPYLIST)The message list:elink.
:li.:link reftype=hd res(PID_R_CMDLINE)Command line parameters:elink.
:li.:link reftype=hd res(PID_LIMITATIONS)Known limitations:elink.
:eol.
.*
.*************************************************************************
:h1 res(PID_KEYSHELP)Keys Help
.*************************************************************************
:p.All OS/2 keys are functional while you are using :hp4.PMSPY:ehp4..
See the OS/2 keys help for a complete list of these keys.
:p.In addition, :hp3.fast path:ehp3. keys have been defined for selected
:hp4.PMSPY:ehp4. actions.  These are indicated when an action bar item is
selected and its pulldowns are displayed.
.*
.*************************************************************************
:h1 res(PID_HELPHELP)Help for Help
.*************************************************************************
.*
:p.Help is always available.
The type of help you get is determined by
the item you selected when you requested help.
.*
:p.When you ask for
help, you will see a window containing help information.
You can size or move this window like any other.
You can also leave the help window visible while you do the task.
.*
.*************************************************************************
:h1 res(PID_LIMITATIONS)Known Limitations
.*************************************************************************
:i2 refid=iSPY.Limitations
.*
:p.The following limitations are known:
:ol.
:li.There is NO profile error reporting (for example, you may be able to
generate multiple occurrences of the same group and/or message)
.*
:li.If PMSPYHK.DLL is not found along :hp2.LIBPATH:ehp2., :hp4.PMSPY:ehp4.
will not start.  The message &apos.SYS1804 file not found&apos. is issued
with the explanation that this is an invalid command.
.*
:eol.
.*
.*************************************************************************
:h1 res(PID_HOW_IT_WORKS)How Does PMSPY Work?
.*************************************************************************
:i2 refid=iSPY.How does it work?
.*
:p.After you
:link reftype=hd res(ID_SELECT)select a target window:elink.,
:hp4.PMSPY:ehp4. installs an INPUT and SENDMSG :hp3.hook:ehp3. into the
window&apos.s message
queue.  This allows the :hp3.spying:ehp3.
of all the messages destined for the window.
.*
:p.If you have requested to spy on the :hp2.queue:ehp2.,
you will see all messages going
through this queue, which means you get the messages from all the windows
associated with this queue.  This is particularly important when you want
to debug dialogs.
.*
.*************************************************************************
:h1 res(PID_HOWTO)How do I do it?
.*************************************************************************
:i2 refid=iSPY.How do I do it?
.*
Here&apos.s some actions you may want to know :hp3.how-to-do:ehp3.
Double-click on the highlighted phrase to move to its detailed explanation.
:ul compact.
.*
:li.To debug a
:link reftype=hd res(PID_HOWTO_DIALOGS)dialog procedure:elink.
.*
:li.To see all
:link reftype=hd res(ID_F_INC_WM_USER)WM_USER:elink. messages
.*
:li.To see all
:link reftype=hd res(ID_F_INC_UNDEFINED)unknown:elink. messages
.*
:li.To freeze the spy message list and automatically
:link reftype=hd res(PID_TRIGGER)thaw it when a trigger message:elink.
is detected
.*
:li.To thaw the spy message list and automatically
:link reftype=hd res(PID_TRIGGER)freeze it when a trigger message:elink.
is detected
.*
:li.To
:link reftype=hd res(DLG_NOTES)add a text note:elink.
to the spy list and (maybe) log file
.*
:li.To
:link reftype=hd res(PID_SAVE)save agent characteristics:elink.
(like the :hp2.font:ehp2. you selected for the spy
list, window position and size)
for the next time you run :hp4.PMSPY:ehp4.
.*
:eul.
.*
.*************************************************************************
:h1 res(PID_HOWTO_DIALOGS)How do I debug dialog procs?
.*************************************************************************
:i2 refid=iHOWTO.debug dialog procs
.*
To debug :hp2.dialog procedures:ehp2.&colon.
:ol compact.
.*
:li.Use :hp2.Select window:ehp2. and select the
:hp2.parent (frame) window:ehp2. for spying.  This is because
the dialog you want
to debug will share the same message queue once its created.
:li.Use :hp2.Spy on queue:ehp2. to be sure that you are spying
on all messages that all moving through the message queue.
This will include the frame and all subsequent dialogs.
.*
:li.Start the dialog.  You should be able to see :hp2.WM_CREATE:ehp2.
messages for each dialog control as well as the :hp2.WM_INITDLG:ehp2.
message that comes to your dialog procedure.
.*
:eol.
.*
.*************************************************************************
:h1 res(PID_SAVE)Saving agent characteristics
.*************************************************************************
:i2 refid=iSPY.Saving agent characteristics
:i2 refid=iHOWTO.Saving agent characteristics
.*
To save characteristics about agent window(s)
(like the :hp2.font:ehp2. you selected to be used for the spy
list, where you positioned the window, how big you sized the window, etc)
for subsequent :hp4.PMSPY:ehp4. uses,
use one of the :hp2.Save:ehp2. options from the
:hp3.OS/2 Desktop Manager:ehp3. pulldowns.
.*
:p.Data is saved
on a per :hp3.agent:ehp3. basis in the file PMSPY.INI.  The file is
placed in the current directory.
.*
:p.Each time :hp4.PMSPY:ehp4. starts,
it tries to use any data previously saved for the :hp3.agent:ehp3.
currently being started (1, 2, and so on)  If this data is not available,
default values are automatically used.
.*
.*************************************************************************
:h1 res(PID_HOW_TO_INSTALL)How to Install and Use PMSPY
.*************************************************************************
:i2 refid=iSPY.Installing
:i2 refid=iSPY.Using
:ol.
:li.All the files needed to run PMSPY can be found in the
C&colon.&bsl.IBMWF&bsl.PRJ&bsl.PMSPY directory (where C&colon.&bsl.IBMWF
should be replaced by the directory you installed into if different):
:dl tsize=16.
:dthd.File Name
:ddhd.Description
:dt.PMSPY.EXE
:dd.Executable code
:dt.PMSPY.HLP
:dd.Help library
:dt.PMSPY.DLL
:dd.Externalized PM resources (strings, messages, dialog templates, etc)
:dt.PMSPYHK.DLL
:dd.Dynamic link library containing "hook" code
:edl.
.*
:li.Copy PMSPY.DLL and PMSPYHK.DLL into a subdirectory which is
accessible using the :hp2.LIBPATH:ehp2. statement in the CONFIG.SYS
file (e.g. C&colon.&bsl.OS2&bsl.DLL) or add the path to the LIBPATH
statement and reboot (only after having made all CONFIG.SYS changes).
.*
:li.Copy PMSPY.EXE into a subdirectory which is in your :hp2.PATH:ehp2.
statement in the CONFIG.SYS file (e.g. C&colon.&bsl.OS2) or add the path
to the PATH statement.
.*
:li.Copy PMSPY.HLP into a subdirectory which is in your :hp2.HELP:ehp2.
statement in the CONFIG.SYS file (e.g. C&colon.&bsl.OS2&bsl.HELP) or add
the path to the HELP statement.
.*
:li.To be able to access :hp4.PMSPY:ehp4. you have a few choices:
.*
:ol.
:li.Add an entry for :hp4.PMSPY:ehp4. in one of your OS/2 folders defining
PMSPY.EXE to be executed from the drive and path where you placed the code
in the step above.
.*
:li.Add an entry for :hp4.PMSPY:ehp4. in the Tools pulldown of WorkFrame/2
by using the 'Tools' item under the 'Configure' pulldown.
.*
:li.Create a :hp4.PMSPY:ehp4. project that points to the PMSPY directory and
has PMSPY.EXE as the target file.
.*
:eol.
.*
:li.When you&apos.re ready to &apos.spy&apos., just invoke :hp4.PMSPY:ehp4.
using the method appropriate to the way you set up access to it.  You may start
up to AGENTS different instances of :hp4.PMSPY:ehp4. to help you analyze/debug
complex PM applications.
.*
:eol.
.*
.*************************************************************************
:h1 res(PID_SPYLIST)Message List
.*************************************************************************
:i2 refid=iSPY.Message List
:p.:hp4.PMSPY:ehp4. places the following items into the message list:
.*
:ol compact.
.*
:li.Eligible messages (as defined by the user&apos.s profile
and operational settings).
Each list item represents a single PM message.
The columns represent various message data items:
.*
:dl tsize=12.
:dt.Message
:dd.Mnemonic value for the message.
:dt.MP1/MP2
:dd.The two parameters for this message.
:dt.HWND
:dd.The target window HWND.
:dt.Source
:dd.Message was :hp4.P:ehp4.osted or :hp4.S:ehp4.ent to window
:edl.
.*
:li.Programmer entered
:link reftype=hd res(DLG_NOTES)text notes:elink.
.*
:li.:hp4.PMSPY:ehp4. status messages.
.*
:eol.
.*
:p.The horizontal scroll bar can be used to scroll the message data left or
right to position just the data you care about in view.
:p.Here is a sample message list.  It contains notes, status messages, and
PM messages.
:xmp.
" This is a NOTE: ready to be debug session...        "
" PM Spy - Window 3300CC8                             "
" WM_BUTTON1UP           005C002A 00000000 P 03300CC8 "
" WM_FOCUSCHANGE         0C902FB0 00000001 S 03300CC8 "
" WM_ACTIVATE            00000001 02900BA8 S 03300CC8 "
" WM_SETSELECTION        00000001 00000000 S 03300CC8 "
" WM_SETFOCUS            0C902FB0 00000001 S 03300CC8 "
" WM_FOCUSCHANGE         02D00D50 003F0000 S 03300CC8 "
" WM_VSCROLL             00008006 00020000 S 03300CC8 "
" WM_FOCUSCHANGE         02D00D50 003C0001 S 03300CC8 "
" WM_SETFOCUS            02D00D50 00000001 S 03300CC8 "
" WM_VSCROLL             00008006 00070001 S 03300CC8 "
" WM_BUTTON2DOWN         00580085 00000000 P 03300CC8 "
" WM_BUTTON2UP           0039008C 00000000 P 03300CC8 "
" WM_PAINT               00000000 00000000 S 03300CC8 "
" WM_SETFOCUS            0C902FB0 00000000 S 03300CC8 "
" WM_SETSELECTION        00000000 00000000 S 03300CC8 "
" WM_ACTIVATE            00000000 02900BA8 S 03300CC8 "
" This is a NOTE: ready to look at UNDEFINED messages "
" WM_BUTTON2DOWN         004C0093 00000000 P 03300CC8 "
" WM_FOCUSCHANGE         0C902FB0 00000001 S 03300CC8 "
" WM_ACTIVATE            00000001 02900BA8 S 03300CC8 "
" WM_SETFOCUS            0C902FB0 00000001 S 03300CC8 "
" WM_???? (0303)         02470306 00010001 S 03300CC8 "
" WM_???? (0303)         02370306 00010001 S 03300CC8 "
" WM_???? (0303)         02300304 00010001 S 03300CC8 "
" WM_???? (0303)         022D0303 00010001 S 03300CC8 "
" WM_BUTTON2UP           0017002B 00000000 P 03300CC8 "
" WM_???? (0303)         022D0303 00010001 S 03300CC8 "
" WM_???? (0304)         022D0303 00010001 S 03300CC8 "
" WM_PAINT               00000000 00000000 S 03300CC8 "
" WM_SETFOCUS            0C902FB0 00000000 S 03300CC8 "
" WM_SETSELECTION        00000000 00000000 S 03300CC8 "
" WM_ACTIVATE            00000000 02900BA8 S 03300CC8 "
" all done, closing the LOG file                      "
:exmp.
.*
.*************************************************************************
:h1 res(PID_DEFAULT_PROFILE)Default Profile
.*************************************************************************
:i2 refid=iPRO.Default Profile
:i2 refid=iSPY.Default Profile
The default PROFILE defines how :hp4.PMSPY:ehp4. operates "out of the box".
:xmp.
.im pmspydef.pro
:exmp.
.*
.*************************************************************************
:h1 res(PID_TRIGGER)Trigger Messages
.*************************************************************************
:i2 refid=iPRO.Trigger Messages
:i2 refid=iHOWTO.Define Trigger Messages
It is possible to define a set of messages to trigger the automatic
thawing or freezing of the :link reftype=hd res(PID_SPYLIST)message list:elink..
:p.
Currently they can only be defined in a profile, there is no interactive
way to define or change the set of trigger messages.
:p.
An already defined message can be included into the set of trigger
messages by on of the following three commands in the profile:
:xmp.
" TRIGGER "WM_BUTTON2UP"  THAW         /* this would thaw a frozen list           */ "
" TRIGGER "WM_BUTTON2UP"  FREEZE       /* this would freeze a thawed list         */ "
" TRIGGER "WM_BUTTON2UP"  THAW FREEZE  /* this will toggle the status of the list */ "
:exmp.
.*************************************************************************
.* PMSPY - Dialog Help
.*************************************************************************
.*
.*************************************************************************
:h1 res(IDD_FILTER)Selective Message Filtering Dialog
.*************************************************************************
:i2 refid=iDLG.Selective Message Filtering Dialog
.*
:p.This dialog allows you to pick the individual
messages you DO or DO NOT wish to &apos.Spy&apos..
:p.All messages are placed in a scroll list.  You may select
one or more messages at a time.  After you have selected all the
messages you are interested in, select one the following pushbuttons:
.*
:dl tsize=10.
:dt.:hp7.Include:ehp7.
:dd.will enable each selected message to be &apos.Spyed&apos..
:dt.:hp7.Exclude:ehp7.
:dd.will disable each selected message from being &apos.Spyed&apos..
:dt.:hp7.Delete:ehp7.
:dd.will delete each selected message (it can  NO longer be &apos.Spyed&apos.!).
:dt.:hp7.Cancel:ehp7.
:dd.will end the dialog.  NO message filtering values are changed.
:edl.
.*
:p.Notes:
:ul compact.
:li.<Msg ID> indicates that the message is currently included
:li.(Msg ID) indicates that the message is currently excluded
:li.usually you will proceed to this dialog after using either the
&apos.Include All&apos. or &apos.Exclude All&apos. pulldown to set the filter list to
a known state
:li.:hp7.Delete:ehp7.
is normally used when creating custom profiles
:li.the Color list box allows you to additionally highlight included
items with a special color (DO NOT select a color to leave &apos.as is&apos.)
:eul.
.*
.*************************************************************************
:h1 res(ID_GRP_DLG)Group Message Filtering Dialog
.*************************************************************************
:i2 refid=iDLG.Group Message Filtering Dialog
.*
:p.This dialog allows you to pick the messages
you DO or DO NOT wish to &apos.Spy&apos. based on logical groupings of messages.
:p.You may select one or more message groups at a time.  After you have
selected all the groups you are interested in, select one the following
pushbuttons:
.*
:dl tsize=10.
:dt.:hp7.Include:ehp7.
:dd.will enable each selected message group to be &apos.Spyed&apos..
:dt.:hp7.Exclude:ehp7.
:dd.will disable each selected message group from being &apos.Spyed&apos..
:dt.:hp7.Delete:ehp7.
:dd.will delete each selected message group (it can  NO longer be &apos.Spyed&apos.!).
:dt.:hp7.Cancel:ehp7.
:dd.will end the dialog.  NO message filtering values are changed.
:edl.
:p.Notes:
:ul compact.
:li.<GroupID> indicates that the group is currently included
:li.(GroupID) indicates that the group is currently excluded
:li.usually you will proceed to this dialog after using either the
&apos.Include All&apos. or &apos.Exclude All&apos. pulldown to set the filter list to
a known state
:li.:hp7.Delete:ehp7.
is normally used when creating custom profiles
:li.the Color listbox allows you to additionally highlight included
items with a special color (DO NOT select a color to leave &apos.as is&apos.)
:eul.
.*
.*************************************************************************
:h1 res(ID_OW_DLG)OBJECT Window Selection dialog
.*************************************************************************
:i2 refid=iDLG.OBJECT Window Selection
.*
:p.This dialog allows you to select an OBJECT window
to &apos.Spy&apos.. The OBJECT windows have been grouped into two categories:
.*
:dl tsize=15.
:dt.:hp2.System:ehp2.
:dd.have a class name that begins with a &numsign. (like &numsign.4, &numsign.9, etc).
They are created by PM to implement some system function.
There are usually many more SYSTEM object windows compared to APPLICATION
.*
:dt.:hp2.Application:ehp2.
:dd.have a class name that DOES NOT begin with a &numsign..
These are usually created by WinCreateWindow within applications and
have programmer meaningful names like "MyObjectWindow", etc.
There are usually fewer APPLICATION object windows, so these are displayed
by default (and probably the ones you want to debug as an application programmer!)
:edl.
:p.Select the OBJECT window you would like to &apos.Spy&apos. from the list then press a pushbutton:
:dl tsize=18 compact.
:dt.:hp7.Spy On:ehp7.
:dd.begins &apos.Spying&apos. on the selected OBJECT window.
:dt.:hp7.System&amp.App:ehp7.
:dd.display both System and Application created OBJECT windows.
:dt.:hp7.App Only:ehp7.
:dd.display only Application created OBJECT windows (default).
:dt.:hp7.Cancel:ehp7.
:dd.ends the dialog and preserves the current window/queue being &apos.Spyed.
:edl.
.*
.*************************************************************************
:h1 res(DLG_NOTES)Notes dialog
.*************************************************************************
:i2 refid=iDLG.Notes
.*
:p.This dialog allows you to enter a text note that is then placed
in the PMSPY list and possible the LOG file.
:p.You can use these notes to document what is happening, the beginning or
end of a test case, etc.
:p.Enter the desired note text then press one of the pushbuttons.
.*
:dl tsize=12.
.*
:dt.:hp7.OK:ehp7.
:dd.This will accept the note text that you have entered.
If you have entered text,
it will be placed in the PMSPY list and remembered as the :hp2.default:ehp2.
note text for the next dialog invocation.
If you have not entered text, you will be warned by a beep.
.*
:dt.:hp7.Cancel:ehp7.
:dd.This will cancel the dialog.  All note text is discarded.
.*
:edl.
.*
.*************************************************************************
:h1 res(DLG_FONT)Font dialog
.*************************************************************************
:i2 refid=iDLG.Font Selection
.*
:p.This dialog allows you to select which non-proportional font is used
in the PMSPY list.
:p.Select the desired font then press one of the pushbuttons.
.*
:dl tsize=9.
:dt.:hp7.OK:ehp7.
:dd.The PMSPY list will change to use the selected font.
:dt.:hp7.Cancel:ehp7.
:dd.This will cancel the dialog.  All note text is discarded.
.*
:edl.
.*************************************************************************
.* PMSPY - Action Bar and Pulldowns Help
.*************************************************************************
.*
.*------------------------------------------------------------------------
:h1 res(ID_AB_FILE)File
.*------------------------------------------------------------------------
.*
:p.This item allows you to&colon.
:ul compact.
.*
:li.Work with :link reftype=hd res(PID_R_PROFILE)profile files:elink. that
you have created.
:li.Work with a
:link reftype=hd res(PID_R_LOG_FILE)log file:elink.
for saving the
:link reftype=hd res(PID_DEFAULT_PROFILE)message list:elink.
contents on disk.
:li.Work with the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink.
:eul.
.*
.*************************************************************************
:h1 res(ID_F_PROFILE)Message profile
.*************************************************************************
This pulldown allows you to work with
:link reftype=hd res(PID_R_PROFILE)profile files:elink.
that you have created.
.*
.*************************************************************************
:h1 res(ID_F_OPENPROFILE)Open, replace current
.*************************************************************************
:i2 refid=iPRO.Open, replace current
:i2 refid=iMSGFIL.Open, profile, replace current
.*
This pulldown allows you to open a
:link reftype=hd res(PID_R_PROFILE)profile file:elink.
that you have created.  It totally replaces the current profile.
You would want to replace the current profile to insure that only
the specific messages that you are interested in are defined.
:p.A :hp2.file open dialog:ehp2. is opened to let you select the
desired profile file.
.*
.*************************************************************************
:h1 res(ID_F_APPENDPROFILE)Open, append to current
.*************************************************************************
:i2 refid=iPRO.Open, append to current
:i2 refid=iMSGFIL.Open, profile, append to current
.*
This pulldown allows you to open a
:link reftype=hd res(PID_R_PROFILE)profile file:elink. that
you have created.  It is appended to the current profile.
You would want to append to the current profile to only incrementally
add application specific messages to those that are currently defined.
For example, you may create a profile for your application&apos.s WM_USER and
above messages.  You would then append that to the :hp4.PMSPY:ehp4.
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink.
to be able to process standard PM as well as application unique messages.
:p.A :hp2.file open dialog:ehp2. is opened to let you select the
desired profile file.
.*
.*************************************************************************
:h1 res(ID_F_SAVEPROFILE)Save current
.*************************************************************************
:i2 refid=iPRO.Save current
:i2 refid=iMSGFIL.Save to file
.*
This pulldown allows you to save the current profile in a disk file.
For example, you may want to create a custom profile.
After starting :hp4.PMSPY:ehp4., you would then select this pulldown to
save the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink.
in a disk file.
:p.A :hp2.file open dialog:ehp2. is opened to let you select the
desired profile file.
.*
.*************************************************************************
:h1 res(ID_F_LOG)Log file
.*************************************************************************
This pulldown allows you to work with a
:link reftype=hd res(PID_R_LOG_FILE)log file:elink.
.*
.*************************************************************************
:h1 res(ID_F_CLOSELOG)Close
.*************************************************************************
:i2 refid=iLOG.Close
.*
This pulldown allows you to close a
:link reftype=hd res(PID_R_LOG_FILE)log file:elink.
that you have previously opened.
.*
.*************************************************************************
:h1 res(ID_F_OPENLOG)Open
.*************************************************************************
:i2 refid=iLOG.Open
.*
This pulldown allows you to open a
:link reftype=hd res(PID_R_LOG_FILE)log file:elink.
for saving the message list contents.
The log file provides an added debugging and/or learning opportunity
because it contains all of the messages and notes that have occurred
since the log file was opened.
:p.A :hp2.file open dialog:ehp2. is opened to let you select the
desired log file.
.*
.*************************************************************************
:h1 res(ID_F_DEFAULT)Default message profile
.*************************************************************************
.*
This pulldown allows you to work with
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile file:elink.
that is shipped with :hp4.PMSPY:ehp4..
.*
.*************************************************************************
:h1 res(ID_F_OPENDEFAULT)Open, replace current
.*************************************************************************
:i2 refid=iPRO.Open defaults, replace current
:i2 refid=iMSGFIL.Open defaults, replace
.*
This pulldown allows you to
totally replace the current profile with the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile file:elink..
You would want to replace the current profile to restore
:hp4.PMSPY:ehp4. back to its startup state.
.*
.*************************************************************************
:h1 res(ID_F_APPENDDEFAULT)Open, append to current
.*************************************************************************
:i2 refid=iPRO.Open defaults, append to current
:i2 refid=iMSGFIL.Open defaults, append
.*
This pulldown allows you to append the current profile with the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile file:elink..
This would add the standard set of PM messages.  Since :hp4.PMSPY:ehp4.
has already defined the standard messages, this is one less thing that
you as an application developer has to worry about.
.*
.*************************************************************************
:h1 res(ID_O_BROWSEDEFAULT)Browse
.*************************************************************************
:i2 refid=iPRO.Browse default
:i2 refid=iPRODEF.Browse
:i2 refid=iMSGFIL.Browse defaults
.*
This pulldown allows you to browse the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile file:elink..
This provides a handy reference to all of the standard PM messages
(including their hex values).
.*
.*************************************************************************
:h1 res(ID_F_EXIT)Exit
.*************************************************************************
.*
This pulldown allows you to exit PMSPY.
.*
.*------------------------------------------------------------------------
:h1 res(ID_AB_SPYON)Spyon
.*------------------------------------------------------------------------
:p.This item allows you to&colon.
:ul compact.
.*
:li.Select the window to :hp3.spy:ehp3. on
:li.Stop :hp3.spying:ehp3. on a window
.*
:eul.
.*
.*************************************************************************
:h1 res(ID_SELECT)Select window
.*************************************************************************
This pulldown allows you to select a visible window for :hp3.spying:ehp3..
The pointer is changed to a cross-hair to indicate that window selection
is in progress.
Position the pointer over the window you wish to :hp3.spy:ehp3.
and use one of the following mouse actions to complete the selection process:
.*
:dl tsize=24 compact.
:dthd.:hp2.Mouse action:ehp2.
:ddhd.:hp2.What happens then:ehp2.
.*
:dt.:hp7.single-click button &numsign.1:ehp7.
:dd.The window and queue handles will be retrieved for that window and
:hp3.spying:ehp3.
will begin as messages move through the queue or are sent to the window.
The window or queue handle will be displayed in the
:hp4.PMSPY:ehp4. titlebar (depending on your last
:link reftype=hd res(ID_AB_SPYWHAT)SpyWhat:elink. selection).
.*
:dt.:hp7.single-click button &numsign.2:ehp7.
:dd.Reveals the
class name, window and queue handles for the window beneath the cursor.
The selection process remains active.  This is a handy way to
explore the current set of windows.
.*
:dt.:hp7.double-click button &numsign.2:ehp7.
:dd.Cancels the selection of a window.
.*
:edl.
.*
.*************************************************************************
:h1 res(ID_SELECT_OBJECT)Select object
.*************************************************************************
:p.This pulldowns allows you to
select an invisible OBJECT window for :hp3.spying:ehp3..
.*
A :link reftype=hd res(ID_OW_DLG)list:elink.
containing all of the System and/or Application OBJECT windows is displayed
for selection.
.*
.*************************************************************************
:h1 res(ID_DESELECT)Deselect current
.*************************************************************************
This pulldowns allows you to stop :hp3.spying:ehp3.
on the current window or OBJECT.
.*
.*------------------------------------------------------------------------
:h1 res(ID_AB_SPYWHAT)SpyWhat
.*------------------------------------------------------------------------
:p.This item allows you to&colon.
:ul compact.
.*
:li.:hp3.Spy on:ehp3. the selected window only
:li.:hp3.Spy on:ehp3. all windows supported by the current message queue
.*
:eul.
.*
.*************************************************************************
:h1 res(IDD_WND)Spy on window
.*************************************************************************
This pulldown limits the :hp3.spying:ehp3.
of messages to only those destined for the current window or OBJECT.
All messages in the message queue not destined for the window are
ignored.
.*
.*************************************************************************
:h1 res(IDD_QUE)Spy on queue
.*************************************************************************
This pulldown expands the :hp3.spying:ehp3. scope
to include messages for all windows supported by the
current message queue.
This capability to examine all windows is required if you desire to
debug :link reftype=hd res(PID_HOWTO_DIALOGS)dialogs:elink..
.*
.*------------------------------------------------------------------------
:h1 res(ID_AB_OPTIONS)Options
.*------------------------------------------------------------------------
:p.This item allows you to&colon.
:ul compact.
:li.Control the :link reftype=hd res(PID_SPYLIST) message list:elink.
:li.Control the :link reftype=hd res(PID_R_LOG_FILE)log file:elink.
:li.Add a :link reftype=hd res(DLG_NOTES)text note:elink.
:eul
.*
.*************************************************************************
:h1 res(ID_O_LIST)Spy list
.*************************************************************************
This set of pulldowns allow you to control
:link reftype=hd res(PID_SPYLIST)message list:elink.
operations.
.*
.*************************************************************************
:h1 res(ID_O_CLEAR)Clear
.*************************************************************************
:i2 refid=iLIST.Clear
.*
This pulldown clears all of the messages and/or notes from the
:link reftype=hd res(PID_SPYLIST)message list:elink..
:p.You may want to clear the list as part of the setup for debugging
a special problem.
.*
.*************************************************************************
:h1 res(ID_O_FREEZE)Freeze
.*************************************************************************
:i2 refid=iLIST.Freeze
.*
This pulldown :hp3.freezes:ehp3. the
:link reftype=hd res(PID_SPYLIST)message list:elink..
This means that no new messages will be automatically added to the
list until you
:link reftype=hd res(ID_O_THAW)thaw the message list:elink..
.*
.*************************************************************************
:h1 res(ID_O_THAW)Thaw
.*************************************************************************
:i2 refid=iLIST.Thaw
.*
This pulldown :hp3.thaws:ehp3. a previously frozen
:link reftype=hd res(PID_SPYLIST)message list:elink..
This means that new, eligible messages will again be automatically added to the
list.
.*
.*************************************************************************
:h1 res(ID_O_SCROLL)Auto scroll?
.*************************************************************************
:i2 refid=iLIST.Auto scroll?
.*
This pulldown represents the :hp3.automatic scrolling:ehp3.
state of
the :link reftype=hd res(PID_SPYLIST)message list:elink..
.*
:p.When :hp2.checked:ehp2., the message list will automatically scroll to
keep the last added message visible.  This is the default setting.
.*
:p.When :hp2.not checked:ehp2., the list does not
automatically scroll to keep the last added message visible.
This is useful when you need to examine the messages that have previously
been added to the list and do not want to be bothered by the automatic scrolling
that occurs when a new message is subsequently added to the list.
.*
.*************************************************************************
:h1 res(ID_O_FONT)Font
.*************************************************************************
:i2 refid=iLIST.Font
.*
This pulldown presents the
:link reftype=hd res(DLG_FONT)Font dialog:elink. so that you can select
the non-proportional font to be in displaying
the :link reftype=hd res(PID_SPYLIST)message list:elink..
.*
.*************************************************************************
:h1 res(ID_O_LOG)Log file
.*************************************************************************
This set of pulldowns allow you to control
:link reftype=hd res(PID_R_LOG_FILE)log file:elink.
operations.
.*
.*************************************************************************
:h1 res(ID_O_STOPLOG)Freeze
.*************************************************************************
:i2 refid=iLOG.Freeze
.*
This pulldown :hp3.freezes:ehp3. the
:link reftype=hd res(PID_R_LOG_FILE)log file:elink..
This means that no new messages are automatically written to the
file (even though they are added to the
:link reftype=hd res(PID_SPYLIST)message list:elink.).
.*
.*************************************************************************
:h1 res(ID_O_STARTLOG)Thaw
.*************************************************************************
:i2 refid=iLOG.Thaw
.*
This pulldown :hp3.thaws:ehp3. a previously frozen
:link reftype=hd res(PID_R_LOG_FILE)log file:elink..
This means that new messages are also automatically written to the
file (as well as being added to the
:link reftype=hd res(PID_SPYLIST)message list:elink.).
.*
.*************************************************************************
:h1 res(ID_O_NOTES)Add note
.*************************************************************************
:i2 refid=iLIST.Add note
:i2 refid=iLOG.Add note
.*
This pulldown presents the
:link reftype=hd res(DLG_NOTES)Notes dialog:elink. so that you can
enter a text note for addition to the
:link reftype=hd res(PID_SPYLIST)message list:elink. and possibly the
:link reftype=hd res(PID_R_LOG_FILE)log file:elink..
:p.You can use notes to document scenario setups, debugging notes, etc
for later reference or debugging assistance.
.*
.*------------------------------------------------------------------------
:h1 res(ID_AB_FILTER)Filter
.*------------------------------------------------------------------------
:p.This item allows you to&colon.
:ul compact.
:li.Control the :hp3.spying:ehp3. of profile defined messages
(on a group or individual message basis)
:li.Control the :hp3.spying:ehp3. on undefined messages
:eul.
.*
.*************************************************************************
:h1 res(ID_F_GROUP)By group
.*************************************************************************
This pulldown presents the
:link reftype=hd res(ID_GRP_DLG)Group Message Filtering dialog:elink.
so that you can select one or more :hp2.groups:ehp2. of messages.
Each group represents one or more individual messages that are logically
related to each other (for instance, all titlebar messages, etc).
Message groups are defined by :hp4.PMSPY:ehp4. in the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink.
or by you in a
:link reftype=hd res(PID_R_PROFILE)profile file:elink..
.*
.*************************************************************************
:h1 res(ID_F_SELECTIVE)By message
.*************************************************************************
This pulldown presents the
:link reftype=hd res(IDD_FILTER)Selective Message Filtering dialog:elink.
so that you can select one or more :hp2.messages:ehp2..
Messages are defined by :hp4.PMSPY:ehp4. in the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink.
or by you in a
:link reftype=hd res(PID_R_PROFILE)profile file:elink..
.*
.*************************************************************************
:h1 res(ID_F_EXCLUDE)Exclude all messages
.*************************************************************************
This pulldown automatically excludes all defined messages (and groups)
from being included in the
:link reftype=hd res(PID_SPYLIST)message list:elink..
By itself, this function is not very useful.  But when used before the
:link reftype=hd res(ID_GRP_DLG)Groupe Filtering dialog:elink. or the
:link reftype=hd res(IDD_FILTER)Selective Message Filtering dialog:elink.
it provides a quick method for placing the message filtering controls
into a known state before setting up special filter combinations.
.*
.*************************************************************************
:h1 res(ID_F_INCLUDE)Include all messages
.*************************************************************************
This pulldown automatically enables the inclusion of all defined
messages (and groups) in the
:link reftype=hd res(PID_SPYLIST)message list:elink..
By itself, this function is not very useful.  But when used before the
:link reftype=hd res(ID_GRP_DLG)Group Message Filtering dialog:elink. or the
:link reftype=hd res(IDD_FILTER)Selective Message Filtering dialog:elink.
it provides a quick method for placing the message filtering controls
into a known state before setting up special filter combinations.
.*
.*************************************************************************
:h1 res(ID_F_INC_UNDEFINED)Include undefined messages?
.*************************************************************************
:i2 refid=iHOWTO.Spy on undefined messages
.*
This pulldown allows you to :hp2.spy:ehp2. on messages that have not
been defined in the current
:link reftype=hd res(PID_R_PROFILE)profile file:elink..
This allows you to spy on other applications and see the non-standard
messages that are used (for example, the messages used with a program
group dialog when items are selected and dragged from one line to another).
The :link reftype=hd res(ID_F_INC_WM_USER)Include undefined WM_USER:elink.
pulldown allow you to just include undefined messages that begin at the
WM_USER value.
.*
:p.The following special format is used when displaying undefined messages&colon.
:xmp.
" WM_???? (0303) 01B40372 00010001 S 03300CC8 "
:exmp.
.*
:p.To examine just the undefined messages, first use the
:link reftype=hd res(ID_F_EXCLUDE)Exclude all messages:elink.,
then select this pulldown item.
.*
.*************************************************************************
:h1 res(ID_F_INC_WM_USER)Include undefined WM_USER?
.*************************************************************************
:i2 refid=iHOWTO.Spy on undefined WM_USER messages
.*
This pulldown allows you to :hp2.spy:ehp2. on all messages defined
at or above the WM_USER value that have not been defined in the current
:link reftype=hd res(PID_R_PROFILE)profile file:elink..
.*
This allows you to spy on your (or other) applications and see
the WM_USER messages being used without having to define a
special profile file.
.*
The :link reftype=hd res(ID_F_INC_UNDEFINED)Include undefined messages?:elink.
pulldown allow you to include all undefined messages.
.*
:p.The following special format is used when displaying undefined
WM_USER messages&colon.
:xmp.
" WM_USER (1010) 01B40372 00010001 S 03300CC8 "
:exmp.
.*
:p.To examine just the WM_USER messages, first use the
:link reftype=hd res(ID_F_EXCLUDE)Exclude all messages:elink.,
then select this pulldown item.
.*
.*------------------------------------------------------------------------
:h1 res(ID_AB_HELP)Help
.*------------------------------------------------------------------------
:p.This item allows you to&colon.
:ul compact.
:li.Obtain operational help on using :hp4.PMSPY:ehp4.
:li.Display :hp4.PMSPY:ehp4. product information
:eul.
.*
.*************************************************************************
:h1 res(ID_H_HELP)Help for help
.*************************************************************************
This pulldown provides help on using the online help system.
.*
.*************************************************************************
:h1 res(ID_H_KEYS)Keys help
.*************************************************************************
This pulldown provides information about the various keyboard keys
and their usage.
.*
.*************************************************************************
:h1 res(ID_H_EXTENDED)Extended help
.*************************************************************************
This pulldown provides extended help about :hp4.PMSPY:ehp4..
.*
.*************************************************************************
:h1 res(ID_H_INDEX)Extended index
.*************************************************************************
This pulldown provides an index of all help topics.
.*
.*************************************************************************
:h1 res(ID_H_ABOUT)Product Information
.*************************************************************************
This pulldown provides information about this version of :hp4.PMSPY:ehp4..
.*************************************************************************
.* PMSPY - Message Help
.*************************************************************************
.*
.*************************************************************************
:h1 res(IDS_MSG_IPF_INIT_1)WinCreateHelpInstance error
.*************************************************************************
:i2 refid=iMsg.WinCreateHelpInstance error
.*
:p.An error was detected during a WinCreateHelpInstance call.
.*
.*************************************************************************
:h1 res(IDS_MSG_IPF_INIT_2)WinAssociateHelpInstance error
.*************************************************************************
:i2 refid=iMsg.WinAssociateHelpInstance error
.*
:p.An error was detected during a WinAssociateHelpInstance call.
.*
.*************************************************************************
:h1 res(IDS_MSG_IPF_ERROR_1)IPF Processing error
.*************************************************************************
:i2 refid=iMsg.IPF Processing error
.*
:p.An IPF error was detected.
.*
.*************************************************************************
:h1 res(IDS_MSG_TOO_MANY_SPIES)Too many PMSPY instances
.*************************************************************************
:i2 refid=iMsg.Too many PMSPY instances
.*
:p.There are already AGENTS :hp4.PMSPY:ehp4. agents active.  No more can be started
at this time.  Re-use one of current :hp4.PMSPY:ehp4. instances to process a new
message queue or window.
.*
.*************************************************************************
:h1 res(IDS_FMT_LEVEL)Executible and "Hook" DLL Incompatible
.*************************************************************************
:i2 refid=iMsg.Executable and "Hook" DLL Incompatible
.*
:p.The internal versions of PMSPY.EXE and PMSPYHK.DLL are not compatible.
Insure that the :hp2.LIBPATH:ehp2. and
:hp2.PATH:ehp2. environment variables locate compatible
files.  If necessary, re-install :hp4.PMSPY:ehp4..
.*
.*************************************************************************
:h1 res(IDS_FMT_SPY_THE_SPY)Can&apos.t spy on PMSPY
.*************************************************************************
:i2 refid=iMsg.Can&apos.t spy on PMSPY
.*
:p.Sorry, you are not allowed to :hp2.spy:ehp2. on :hp4.PMSPY:ehp4....
.*
.*************************************************************************
:h1 res(IDS_MSG_LOG_EXISTS)Log file already exists
.*************************************************************************
:i2 refid=iMsg.Log file already exists
.*
:p.The :hp2.log:ehp2. file you selected already exists.  This message
requests verification before replacing the existing file.
.*
.*************************************************************************
:h1 res(IDS_MSG_PROFILE_EXISTS)Profile file already exists
.*************************************************************************
:i2 refid=iMsg.Profile file already exists
.*
:p.The :hp2.profile:ehp2. file you selected for saving already exists.
This message
requests verification before replacing the existing file.

.*************************************************************************
.* PMSPY - Reference Help
.*************************************************************************
.*
.*************************************************************************
:h1 res(PID_R_PROFILE)Profile file
.*************************************************************************
:i2 refid=iPRO.Syntax
.*
:p.An optional profile can be used to define colors
and message filtering options. The file is interpreted sequentially.
One advantage of creating a profile for your application is that you
define the message name to have the same mnemonic value as you used when
you coded it (for example, WM_STARTUP_PROCESSING)  It is even
possible to automate the generation of application specific profiles
to insure that they remain consistent with your application code
as it changes during the development cycle.
:p.For an example, look at the
:link reftype=hd res(PID_DEFAULT_PROFILE)default profile:elink..
.*
:xmp.
"  X       <n>                                 /* x position of window */           "
"  Y       <n>                                 /* y position of window */           "
"  CX      <n>                                 /* width of window */                "
"  CY      <n>                                 /* height of window */               "
"                                                                                   "
"  SPYON   <WINDOW> | <QUEUE>                  /* spy on a window or a queue */     "
"                                                                                   "
"  LIST    <THAW> | <FREEZE>                   /* the list is thawed or frozen */   "
"                                                                                   "
"  FONT    <&cdq.10.System Monospaced&cdq.>            /* the font to use in the listbox */ "
"                                                                                   "
"  COLOR   <color> <SYSCLR_xxx> | <CLR_xxx>    /* define own Color */               "
"                                                                                   "
"  GROUP   <GroupID> [<color>]                 /* define Message Group */           "
"  DEFINE  <MsgID> <MsgNo> [<color>]           /* define Message in Group */        "
"                                                                                   "
"  INCLUDE ALL | <GroupID> | <MsgID>           /* Include message(s) */             "
"  EXCLUDE ALL | <GroupID> | <MsgID>           /* Exclude message(s) */             "
"                                                                                   "
"  TRIGGER <MsgID>     <THAW> <FREEZE>         /* trigger message(s) */             "
"                                                                                   "
"  /* | * | <Null>                             /* comment lines ignored */          "
"                                                                                   "
"  * <color> is 1..8 (1=default color; omit to leave default color ASIS)            "
"                                                                                   "
"                     1=color used for undefined messages                           "
"                     2=color used for undefined WM_USER messages                   "
"                     7=color used for NOTES                                        "
"                     8=color used for PMSPY status messages                        "
"  * <MsgID> is a blank delimited "word" (optionally it may be enclosed in          "
"                                         double quotes)                            "
"  * <MsgNo> is a decimal, hex, or octal (for those DEC fans) number                "
"  * <GroupID> is a blank delimited "word" (optionally it may be enclosed in        "
"                                           double quotes)                          "
:exmp.
.*
.*************************************************************************
:h1 res(PID_R_CMDLINE)Command Line
.*************************************************************************
:p.The following command line parameters are all optional and case insensitive.
They are processed as they are found (left-to-right).
:xmp.
   :hp4.PMSPY:ehp4. [/PRO=file] [/APP=file]
:exmp.
:dl tsize=14.
:dt./PRO=file
:dd.reads <file> as a profile and :hp2.replaces:ehp2. the default profile.
.*
:dt./APP=file
:dd.reads <file> as a profile and :hp2.appends:ehp2. it to the default profile.
:edl.
.*
:p.Combinations of :hp2./PRO=:ehp2. and
:hp2./APP=:ehp2. may be used on one invocation to setup
special filtering situations.  For example, the following invocation
establishes an application specific filter set composed of two groups
of messages (without using the &apos.standard&apos. PM message set):
.*
:xmp.
    :hp4.PMSPY:ehp4. /PRO=app-set1.pro /APP=app-set2.pro
:exmp.
:p.The first :hp2./PRO=:ehp2. "clears" the default message filtering set
then loads the
message groups defined in APP-SET1.PRO.
The :hp2./APP=:ehp2. then adds the additional
messages groups defined in APP-SET2.PRO.
.*
.*************************************************************************
:h1 res(PID_R_LOG_FILE)Log file
.*************************************************************************
.*
This file can be used to save the contents of the
:link reftype=hd res(PID_SPYLIST)message list:elink. on disk.  All
messages and
:link reftype=hd res(DLG_NOTES)text notes:elink.
are written to the log file if one has been opened.
:p.One advantage of using a log file is that you can view :hp2.all:ehp2.
of the messages that have occurred.  Due to listbox limitations, the oldest
messages are deleted from the listbox to make room for the ones currently
occurring.
:p.The following is a sample log file:
:xmp.
" PM Spy - Window 3300CC8                             "
" WM_BUTTON1UP           00430067 00000000 P 03300CC8 "
" WM_FOCUSCHANGE         0C702D8C 00000001 S 03300CC8 "
" WM_ACTIVATE            00000001 02900BA8 S 03300CC8 "
" WM_SETSELECTION        00000001 00000000 S 03300CC8 "
" WM_SETFOCUS            0C702D8C 00000001 S 03300CC8 "
" WM_FOCUSCHANGE         02D00D50 003F0000 S 03300CC8 "
" WM_VSCROLL             00008006 00020000 S 03300CC8 "
" WM_FOCUSCHANGE         02D00D50 003C0001 S 03300CC8 "
" WM_SETFOCUS            02D00D50 00000001 S 03300CC8 "
" WM_VSCROLL             00008006 00070001 S 03300CC8 "
" WM_FOCUSCHANGE         02D00D50 003F0000 S 03300CC8 "
" WM_VSCROLL             00008006 00020000 S 03300CC8 "
" WM_FOCUSCHANGE         02D00D50 003C0001 S 03300CC8 "
" WM_SETFOCUS            02D00D50 00000001 S 03300CC8 "
" WM_VSCROLL             00008006 00070001 S 03300CC8 "
" WM_TRANSLATEACCEL      04CF0C10 00000000 S 03300CC8 "
" WM_CHAR                61011006 001648D0 P 03300CC8 "
" WM_TRANSLATEACCEL      04CF0C10 00000000 S 03300CC8 "
" WM_CHAR                61011146 001648D0 P 03300CC8 "
" WM_BUTTON1DOWN         00410070 00000000 P 03300CC8 "
" WM_BUTTON1UP           00410071 00000000 P 03300CC8 "
" WM_BUTTON1DBLCLK       00410072 00000000 P 03300CC8 "
" WM_BUTTON1UP           00420073 00000000 P 03300CC8 "
" WM_SETFOCUS            14303138 00000000 S 03300CC8 "
" WM_SETSELECTION        00000000 00000000 S 03300CC8 "
" WM_ACTIVATE            00000000 02900BA8 S 03300CC8 "
" WM_FOCUSCHANGE         14303138 00000001 S 03300CC8 "
" WM_ERASEBACKGROUND     010023BD 00D735CA S 03300CC8 "
" WM_PAINT               00000000 00000000 S 03300CC8 "
" WM_ACTIVATE            00000001 02900BA8 S 03300CC8 "
" WM_SETSELECTION        00000001 00000000 S 03300CC8 "
" WM_SETFOCUS            14303138 00000001 S 03300CC8 "
" WM_SETFOCUS            0C702D8C 00000000 S 03300CC8 "
" WM_SETSELECTION        00000000 00000000 S 03300CC8 "
" WM_ACTIVATE            00000000 02900BA8 S 03300CC8 "
:exmp.
:euserdoc.
