#*Ŀ*/
#*                                                                          */
#* PROGRAM NAME: PMSPY                                                      */
#* -------------                                                            */
#*  A PM program that is used to look at or 'spy' on the message queue of   */
#*  other PM applications windows.                                          */
#*                                                                          */
#* COPYRIGHT:                                                               */
#* ----------                                                               */
#*  Copyright (C) International Business Machines Corp., 1991,1992.         */
#*                                                                          */
#* DISCLAIMER OF WARRANTIES:                                                */
#* -------------------------                                                */
#*  The following [enclosed] code is sample code created by IBM Corporation.*/
#*  This sample code is not part of any standard IBM product and is provided*/
#*  to you solely for the purpose of assisting you in the development of    */
#*  your applications.  The code is provided "AS IS", without warranty of   */
#*  any kind.  IBM shall not be liable for any damages arising out of your  */
#*  use of the sample code, even if they have been advised of the           */
#*  possibility of such damages.                                            */
#*                                                                          */
#* For details on what this program does etc., please see the PMSPY.C file. */
#*                                                                          */
#**/
#
#*Ŀ*/
#* PMSPY.MAK                                                                */
#*                                                                          */
#* main makefile                                                            */
#**/

###############################################################################
#
#--------------------------------------------------------------------------
#
# MAKE file for the PMSPY
#
#--------------------------------------------------------------------------
#
# External Requirements:
# ======================
#
# 1) ENVironment variables that MUST be correctly set
#
#    * NO drives, paths, etc are contained in this MAKE file
#
#    * Before using, the following items must be SET:
#
#      - PATH    = where the utilities "live"       [C, LINK, etc]
#
#      - INCLUDE = all paths to look for #include's [C]
#      - TMP     = "home" for temporary work files  [C]
#
#      - LIB     = all paths to look for LIBraries  [LINK]
#
# 2) ENVironment variables that MAY be set
#
#      - CL      = other CL options...              [C]
#
#                  *** Example: override the C PreProcessor used
#
#                      How To:  set cl=/B1 c:\ibmc2\bin\c1l.exe
#
#--------------------------------------------------------------------------
#
# External MAKE MACROs:
# =====================
#
# wantDBG.....generate DEBUG information
#
# wantLST....generate LISTING(s)
#
# Sample Usage: NMAKE PMSPY.MAK wantDBG=1
#
###############################################################################

#wantDBG=1

#------------------------------------------------------------------------------
# Symbolic names for PRODuct pieces
#------------------------------------------------------------------------------

# this is our PRODuct ID

PROD    = PMSPY

PRODVER = 1.00

# definitions for PMSPY.EXE (code and Non-NLS resources)

PRODX    = $(PROD).EXE
PRODXH   = $(PROD).H
PRODXC   = PMSPY.C      PMSPYPRO.C   PMSPYFIL.C   PMSPYFON.C   \
           PMSPYGRP.C   PMSPYIPF.C   PMSPYMSG.C   PMSPYNOT.C   \
           PMSPYWIN.C   PMSPYUTL.C   PMSPYABT.C   PMSPYOW.C
PRODXOBJ = $(PRODXC:.C=.OBJ)
PRODXDEF = $(PROD).DEF
PRODXMAP = $(PROD).MAP
PRODXRC  = $(PROD).RC
PRODXRES = $(PROD).RES
PRODXPRO = $(PROD)DEF.PRO

# definitions for PMSPYHK.DLL ("hook" code)

PRODH    = $(PROD)HK.DLL
PRODHH   = $(PROD)HK.H
PRODHC   = $(PROD)HK.C
PRODHOBJ = $(PROD)HK.OBJ
PRODHDEF = $(PROD)HK.DEF
PRODHLIB = $(PROD)HK.LIB

# definitions for PMSPY.DLL (NLS resources)

PRODN    = $(PROD).DLL
PRODNC   = $(PROD)NLS.C
PRODNOBJ = $(PROD)NLS.OBJ
PRODNDEF = $(PROD)NLS.DEF
PRODNRC  = $(PROD)NLS.RC
PRODNRES = $(PROD)NLS.RES
PRODNH   = $(PROD)RC.H

# definitions for PMSPY.HLP (IPF Help panels)

PRODI    = $(PROD).HLP
PRODIH   = $(PROD)IPF.H
PRODIN   = $(PRODIH) $(PRODNH)
PRODIIPF = $(PROD).IPF

# definitions for PMSPY source modules

PRODSH   = $(PRODXH) $(PRODHH) $(PRODNH)
PRODSHI  = $(PRODSH) $(PRODIH)

#------------------------------------------------------------------------------
# C parameters
#------------------------------------------------------------------------------

cWARN           = /W3
cMEM            =
cOPTS           = /c /Gs- /Ss

# decide about listings..

!ifdef wantLST
cLST            = /Lf /Lt "OS/2 2.0 PMSPY" /Lu "Version $(PRODVER)"
!endif

# decide about Debug Info...

!ifdef wantDBG
cOPTS           = $(cOPTS) /O- /Ti+
!else
cOPTS           = $(cOPTS) /O+
!endif

!ifdef TEE
teeline=| tee $*.err
!endif

#------------------------------------------------------------------------------
# LINK parameters
#------------------------------------------------------------------------------

lMain           = /MAP /NOI /ALIGN:16 /EXEPACK

!ifdef wantDBG
lMain           = $(lMain) /CO /LI
!endif

#------------------------------------------------------------------------------
# *** THIS is THE inference rule to generate our code.... ***
#------------------------------------------------------------------------------

.C.OBJ:
  @-erase $*.ERR $*.OBJ 2>NUL
  icc  $(cOPTS) $(cMEM) $(cWARN) $*.C $(teeline)

#------------------------------------------------------------------------------
# *** THIS is THE major dependency rule...it forces anything to happen
#------------------------------------------------------------------------------

$(PROD):     $(PRODX) \
             $(PRODH) \
             $(PRODN) \
             $(PRODI)

#------------------------------------------------------------------------------
# Generate PMSPY.EXE (Code and Non-NLS resources)
#------------------------------------------------------------------------------

$(PRODX):     $(PRODXOBJ) \
              $(PRODXDEF) \
              $(PRODXRES) \
              $(PRODHLIB)
  link386 $(lMain) /PM:PM /BASE:65536 @<<
$(PRODXOBJ)
$(PRODX)
$(PRODXMAP)
$(PRODHLIB)
$(PRODXDEF)
<<
  rc $(PRODXRES) $(PRODX)

$(PRODXRES):  $(PRODXRC)          \
              $(PRODNH)           \
              $(PRODIH)           \
              $(PROD).ICO         \
              $(PROD).PTR         \
              $(PRODXPRO)
  rc -r $(PRODXRC)

$(PRODXPRO)  : PMSPYDEF.EXE
  PMSPYDEF

PMSPYDEF.EXE : PMSPYDEF.OBJ
  link386 $(lMain) /PM:VIO /BASE:65536 @<<
PMSPYDEF.OBJ
PMSPYDEF.EXE
NUL


<<

#-------------------------------------------------------------------------------
# Generate PMSPYHK.DLL ("Hook" code)
#------------------------------------------------------------------------------

$(PRODH) : $(PRODHOBJ) $(PRODHDEF)
  link386 $(lMain) /NOE @<<
$(PRODHOBJ)
$(PRODH)
NUL

$(PRODHDEF)
<<

#-------------------------------------------------------------------------------
# Generate PMSPYHK.LIB (Import LIB for "Hook" code)
#------------------------------------------------------------------------------

$(PRODHLIB) : $(PRODH)
  implib $(PRODHLIB) $(PRODHDEF)

#-------------------------------------------------------------------------------
# Generate PMSPY.DLL (NLS resources)
#------------------------------------------------------------------------------

$(PRODN):     $(PRODNOBJ)         \
              $(PRODNDEF)         \
              $(PRODNRES)
  link386 $(lMain) @<<
$(PRODNOBJ)
$(PRODN)
NUL

$(PRODNDEF)
<<
  rc $(PRODNRES) $(PRODN)

$(PRODNRES):  $(PRODNRC)          \
              $(PRODNH)           \
              $(PROD).ICO
  rc -r $(PRODNRC)

#-------------------------------------------------------------------------------
# Generate PMSPY.HLP (IPF Help panels)
#------------------------------------------------------------------------------

$(PRODI):     $(PRODIIPF) $(PRODIN)
  icc /c /P /DIPF /Ss $(PRODIIPF)
  ipfc $(PRODI:.HLP=.I)
  @-del $(PRODI:.HLP=.I) 2>NUL

#------------------------------------------------------------------------------
# Individual components
#------------------------------------------------------------------------------

PMSPY.OBJ:    PMSPY.C    $(PRODSH)

PMSPYABT.OBJ: PMSPYABT.C $(PRODSH)

PMSPYDEF.OBJ: PMSPYDEF.C
  @-erase $*.ERR $*.OBJ 2>NUL
  icc  $(cOPTS) $(cMEM) $(cWARN) /DV20 $*.C $(teeline)

PMSPYFIL.OBJ: PMSPYFIL.C $(PRODSH)

PMSPYFON.OBJ: PMSPYFON.C $(PRODSH)

PMSPYGRP.OBJ: PMSPYGRP.C $(PRODSH)

PMSPYHK.OBJ:  PMSPYHK.C  $(PRODHH)
  @-erase $*.ERR $*.OBJ 2>NUL
  icc $(cOPTS) /Rn /Ge- pmspyhk.c $(teeline)

PMSPYIPF.OBJ: PMSPYIPF.C $(PRODSH)

PMSPYMSG.OBJ: PMSPYMSG.C $(PRODSH)

PMSPYNLS.OBJ: PMSPYNLS.C
  @-erase $*.ERR $*.OBJ 2>NUL
  icc $(cOPTS) pmspynls.c $(teeline)

PMSPYNOT.OBJ: PMSPYNOT.C $(PRODSH)

PMSPYOW.OBJ:  PMSPYOW.C  $(PRODSH)

PMSPYPRO.OBJ: PMSPYPRO.C $(PRODSH)

PMSPYUTL.OBJ: PMSPYUTL.C $(PRODSH)

PMSPYWIN.OBJ: PMSPYWIN.C $(PRODSH) $(PRODIH)
