/*Ŀ*/
/*                                                                          */
/* PROGRAM NAME: PMSPY                                                      */
/* -------------                                                            */
/*  A PM program that is used to look at or 'spy' on the message queue of   */
/*  other PM applications windows.                                          */
/*                                                                          */
/* COPYRIGHT:                                                               */
/* ----------                                                               */
/*  Copyright (C) International Business Machines Corp., 1991,1992.         */
/*                                                                          */
/* DISCLAIMER OF WARRANTIES:                                                */
/* -------------------------                                                */
/*  The following [enclosed] code is sample code created by IBM Corporation.*/
/*  This sample code is not part of any standard IBM product and is provided*/
/*  to you solely for the purpose of assisting you in the development of    */
/*  your applications.  The code is provided "AS IS", without warranty of   */
/*  any kind.  IBM shall not be liable for any damages arising out of your  */
/*  use of the sample code, even if they have been advised of the           */
/*  possibility of such damages.                                            */
/*                                                                          */
/* For details on what this program does etc., please see the PMSPY.C file. */
/*                                                                          */
/**/

/*Ŀ*/
/* PMSPYGRP.C                                                               */
/*                                                                          */
/* Group Message Filter Dialog Procedure                                    */
/**/

#include "pmspy.h"

 MRESULT GroupDlgProc(          HWND    hwnd,
                       register ULONG   message,
                                MPARAM  lParam1,
                                MPARAM  lParam2 )

  {

     /*Ŀ*/
     /* Local Variables                                                     */
     /**/

     MRESULT            dpResult = NULL;

     CHAR               ListText[200];

              PGRP_ITEM pGrp;

     register USHORT    list_index,
                        pbSelected;

     static PSPY_DATA   pSpyData = NULL;

  /*Ŀ*/
  /* Process the message                                                    */
  /**/

  switch (message)                                    /* Switch off of the message ID */
  {

    case WM_COMMAND:

      switch( pbSelected = LOUSHORT( lParam1 ) )
      {
          case ID_GRP_PB_EXCLUDE:
          case ID_GRP_PB_DELETE:
          case ID_GRP_PB_INCLUDE:

          {
            register MSG_COLOR color = GetColor( hwnd,pSpyData);

            USHORT             curItem,    /* current list item */
                               nSelected;  /* Number of items selected */

            for(/* Initialize */ nSelected = 0,                    /* Zero out vars                */
                                 curItem   = (USHORT)
                                             WinSendDlgItemMsg(    /* Query 1st selection          */
                                             hwnd,                 /*   Dialog handle              */
                                             ID_GRP_LB_GROUPS,     /*   Listbox ID                 */
                                             LM_QUERYSELECTION,    /*   Query ID of selected       */
                                             (MPARAM)LIT_FIRST,
                                             (MPARAM)NULL);

                /* Terminate  */ curItem != (USHORT)LIT_NONE;

                /* Iterate    */ nSelected++,
                                 curItem   = (USHORT)
                                             WinSendDlgItemMsg(    /* Query next selection         */
                                             hwnd,                 /*   Dialog handle              */
                                             ID_GRP_LB_GROUPS,     /*   Listbox ID                 */
                                             LM_QUERYSELECTION,    /*   Query ID of selected       */
                                             (MPARAM)curItem,
                                             (MPARAM)NULL)
               )
            {
              pGrp = (PGRP_ITEM)
                     WinSendDlgItemMsg( hwnd,
                                        ID_GRP_LB_GROUPS,
                                        LM_QUERYITEMHANDLE, /*   Message                    */
                                        (MPARAM) curItem,   /*   Item to get handle of      */
                                        (MPARAM) NULL);     /*   Reserved                   */

              switch( pbSelected )
              {
                case ID_GRP_PB_DELETE:
                     DeleteGroup(pSpyData, pGrp->GroupID);
                     break;

                case ID_GRP_PB_EXCLUDE:
                     IncludeGroup(pSpyData, pGrp, FALSE, color);
                     break;

                case ID_GRP_PB_INCLUDE:
                     IncludeGroup(pSpyData, pGrp, TRUE, color);
                     break;
              }
            }

            if (nSelected == 0)  /* Selections? */
            {
              WinAlarm(HWND_DESKTOP, WA_ERROR);

              break;                                   /* DO NOT end dialog */
            }
          }

          /*Ŀ*/
          /* ** FALL THROUGH TO END DIALOG **                               */
          /**/

          /*Ŀ*/
          /* User cancelled exclusion/inclusion                             */
          /**/

          case DID_CANCEL:                          /* CANCEL was selected          */

              WinDismissDlg( hwnd,                  /* Close dialog */
                             0 );                   /* WinDlgBox return */

            break;                                  /* Break DID_CANCEL             */
      }
     break;                                         /* Break WM_COMMAND             */

    /*Ŀ*/
    /* WM_CLOSE:                                                            */
    /* - Call WinDismissDlg to close the dialog box                         */
    /**/

    case WM_CLOSE:                                  /* Close Dialog Box.        */

      WinDismissDlg( hwnd, 0);

      break;

    /*Ŀ*/
    /* WM_INITDLG:                                                          */
    /* - Init pointer to data pointed to by WinDlgBox                       */
    /* - Init global handle of this dlg                                     */
    /**/

    case WM_INITDLG:

      /*Ŀ*/
      /* Locate "SPY" data to utilize                                       */
      /**/

      pSpyData = (PSPY_DATA) lParam2;

      /*Ŀ*/
      /* Add all Groups to list box                                         */
      /**/

      for(/* Initialize */ pGrp = ProcessFirstGroup(pSpyData); /* @ 1st GROUP */
          /* Terminate  */ pGrp != NULL;                       /* @ end of list */
          /* Iterate    */ pGrp = ProcessNextGroup(pSpyData)   /* try next GROUP */
         )
      {
        sprintf(ListText,
                pGrp->Include ? Strings[IDS_FMT_GRP_INCLUDED]
                              : Strings[IDS_FMT_GRP_EXCLUDED],
                pGrp->pDesc       /* Group's mnemonic */
               );

        list_index = (USHORT) WinSendDlgItemMsg(      /* Send a message to the list   */
                      hwnd,                           /*   Window Handle              */
                      ID_GRP_LB_GROUPS,
                      LM_INSERTITEM,                  /*   Insert item                */
                      (MPARAM) LIT_SORTASCENDING,     /*   Sort                       */
                      (MPARAM) ListText);             /*   Text                       */

        WinSendDlgItemMsg(                            /* Send a message to the list   */
                      hwnd,                           /*   Window Handle              */
                      ID_GRP_LB_GROUPS,
                      LM_SETITEMHANDLE,               /*   Message                    */
                      (MPARAM)list_index,             /*   Index of list item         */
                      (MPARAM)pGrp);                  /*   Handle of list item        */
      }

      SetColors( hwnd, pSpyData );
      CenterDialog(hwnd);                           /* Center the dialog */
      break;                                        /* WM_INITDLG */

    /*Ŀ*/
    /* This is a MSG we don't care about...                                 */
    /**/

    default:
         if ( !HandleIPF(hwnd, message, lParam1, lParam2, &dpResult) )
           dpResult = WinDefDlgProc(hwnd, message, lParam1, lParam2);
  }

   /*Ŀ*/
   /* Exit                                                                  */
   /**/
   return( dpResult );
}
